/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2015. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextAreaField");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.AbstractFormField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.TextareaBidi");
(function() {
dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextAreaField", 
             com.ibm.asq.common.web.ui.internal.widgets.layout.AbstractFormField,
{
	currentValue: null,
    disabled: false,	    
    
    postCreate: function() {
		this.inherited("postCreate", arguments);
		this.currentValue =  this.currentValue?this.currentValue:this.value;
		var args = {				
				name:this.name,
				value: this.currentValue,
			    disabled: this.disabled
		};		
		if (this.maxLength) {
			args.maxLength = this.maxLength;
	    }
		if(this.cols){
			args.cols = this.cols;			
		}
		if(this.rows){
			args.rows =  this.rows;
		}
		
		var div = document.createElement("div");
		dojo.addClass(div,"outer-wrapper-div text-area-field");
		this.textArea = new com.ibm.asq.common.web.ui.internal.widgets.TextareaBidi(args);
		if (dojo.isIE <= 7) {
			dojo.style(div, "overflow", "hidden");
		}
		this.connect(this.textArea, "onChange", "_valueChangedHandler");
        this.connect(this.textArea, "onKeyUp", "_valueChangedHandler");
        this.connect(this.textArea, "onBlur", "_valueChangedHandler");
        this.connect(this, "onClick", "focusTextArea");
		div.appendChild(this.textArea.domNode);		
		this.fieldHolderNode.appendChild(div);
        this.focusNode = this.textArea.focusNode;
        
        // explicitly set the required attribute on the text field. Only
        // validate text field directly supports required attribute.
		this.focusNode.setAttribute("aria-required", this.isRequired);
		this._attachLabelToField(this.focusNode, this.textArea.id);
		
        if (!this.formValidationStyle){
            this.setHasError(this.isRequired && !(this.currentValue || this.value), this.msgValueIsRequired);
        }
    },
	         
    // Summary:
    //    This method is called when the field's value has been changed. Consumer of the widget 
    //    overrides this method to receive notification of the value changed event.
    //
    onValueChanged: function(oldValue, newValue)
    {
    },
    
    focusTextArea: function() {
		this.textArea.focus();
	},

    _valueChangedHandler: function(e)
    {
        // do not validate on the tab key that got us here
        if (e && e.keyCode && e.keyCode == 0x09) return;
        var oldValue = this.currentValue?this.currentValue:"";
        this.currentValue = this.getValue();                 
        this.setHasError(this.isRequired && !this.currentValue, this.msgValueIsRequired);
		if(oldValue != this.currentValue){
        	this.onValueChanged(this, oldValue, this.currentValue);
		}        
    },
    
    setValue: function(value)
    {
        var val = (value) ? value : "";
        this.textArea.set('value',val);
    },

    clearValue: function() {
        this.setValue("");
    },

    // Summary:
    //    Returns the value from the field. Subclass must override. A null is returned if
    //    no value is specified.
    //
    getValue: function()
    {    	
        var val = this.textArea.get('value');
        return val;
    },
    
    setDisabled: function(disabled)
    {
        this.inherited("setDisabled", arguments);
        this.textArea.set('disabled', disabled);
    },
    
    uninitialize: function() {
    	this.textArea.destroy();
    }
});

})();
