/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2015. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.PlanScriptsSection");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractReadOnlyListViewSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView");

(function() {
    var AbstractReadOnlyListViewSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractReadOnlyListViewSection;
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.PlanScriptsSection", AbstractReadOnlyListViewSection, {
        
        createResultView: function() {
            return new com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView({
                showQueryFilters: true,
                exploreSavedQueries: true,  // support saved queries
                saveQueriesReadOnly: true,  // don't allow saving new queries
                parentItemIdArgName: [ "parentVTestPlan" ],
                parentVersionItemId: [ this.getArtifact().versionableItemId ],
                profile: "TESTCASE",
                tableId: "RQM-TP-TS-SECTION-TABLEVIEWER",
                overrideRunOnOpenPref: true,                
                configurationItemId: this.getParentEditor().configurationItemId,
                includeSnapshots: true
            });
        },
        
        // override to specify no CS help
        getHelpContextID: function(){
            return null;
        }
        
    });
})();