/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011, 2015. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentSection");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentListTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.CustomListDiffMergeSectionMixin");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Configuration");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");


(function() 
{	
	var ContentAreas 						= com.ibm.rqm.planning.web.ui.internal.view.common.InPageContentArea;
	var EnvironmentListTableView			= com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentListTableView;
	var ServiceResponseHandler   			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var AbstractArtifactEditorSection 		= com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var Constants							= com.ibm.rqm.planning.web.client.internal.Constants;
	var AlertDialog 						= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
    var OslcConfigParamName                 = com.ibm.asq.common.web.client.internal.Constants.OSLC_CONFIG_PARAM_NAME;
	var LINK_TYPE_ID						= "com.ibm.rqm.planning.environments";	
	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentSection",
			 [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection, 
			  com.ibm.rqm.planning.web.ui.internal.view.extension.CustomListDiffMergeSectionMixin],
	{
		templateString: '<div class="com-ibm-rqm-test-planning-environment-environmentsection">' +
						'<div dojoAttachpoint="parentContainer">'+
						'    <div class="" dojoattachpoint="_envSection"></div>' +
						'    <div class="" dojoattachpoint="_tabContainer"></div>' + 
						'    <div class="" dojoattachpoint="_environmentsContainer"></div>' +
						'    <div class="" dojoattachpoint="_configurationsContainer"></div>' +
						'</div>'+
						'<div dojoAttachpoint="_mergeListContainer"></div>'+
						'</div>',
		
		constructor: function(args) 
		{
			this.configValues = [];
			this.environmentUpdated = false;
			this.tabs = [];
			this.configurations = [];			
		},
		
		postCreate: function() {
			this.itemType = "com.ibm.rational.test.lm.AssetConfiguration" ;
			this.parentScopeItemType = Constants.MODEL_TYPE_VERSIONED_PLAN;
            this.inherited('postCreate', arguments);
            this.addWorkItemSupport();		            
            this.mergeTableHost  = this._mergeListContainer;            
		},
		
		//@Overriden from AbstractArtifactEditorSection - invoked on first expand
		initialize: function(isEditable)
		{
			if(this.inCustomCompareMerge) {				
        		// if this is the display host for the custom UI,
        		// we will take over the display content. Otherwise,
        		// we won't need to create any content.
        		if(this.isCompareHost) {
        			this._linksAddedType =  LINK_TYPE_ID;
    				this._linksRemovedType = LINK_TYPE_ID;    				
        			dojo.style(this.parentContainer, "display", "none");
        			this._createCustomCompareMergeUI();
        			dojo.connect(this.getParentEditor(), "_startSaving", dojo.hitch(this._compareTableView, "addMergeLinkPendingParticipants"));
        		}        		        		
        		return;
        	}
			this.inherited('initialize', arguments);
			dojo.empty(this._tabContainer)
			
			if(!this.getParentEditor().isCopy())			
				this._plan = this.getArtifact();
			this._configsAdded = [];
			this._configsRemoved = [];

            jazz.core.loader.load_async("com.ibm.rational.test.lm.web.client.internal.config", dojo.hitch(this, "_loadConfigModuleCB"));
		},
		initializeMerge: function() {
			this.inherited('initializeMerge', arguments);
			this.mergeRetry = 0;
		},      				
	
        _loadConfigModuleCB: function() {
			this._configClient = new com.ibm.rational.test.lm.web.client.internal.config();
            setTimeout(dojo.hitch(this, "_postInit"), 250);
        },
        
        _postInit: function() {
            this._initTabContainer();
            this._createCatalog();    
            this.fullyInitialized = true; //For merge purposes, indicates that all data has been fetched
		},
		
		//@Overridden from AbstractArtifactEditorSection
		saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
            this.addWorkItemSupport();
			this.environmentUpdated = false;	
			this._configsAdded = [];
			this._configsRemoved = [];	            
        },
		
        //@Overriden from AbstractArtifactEditorSection
        getAttributes: function(){    
        	if(this.inCustomCompareMerge){
        		return null;
        	}
            var returnArray = [];
			if (this.configValues && this.configValues.length > 0) {
				for (var i = 0; i < this.configValues.length; i++) {
					if (this.configValues[i].catalogEntries.length > 0) {
						var arr = [];
						var object = {
							catalogType: this.configValues[i].catalogType,
							includeInSearch : this.configValues[i].includeInSearch == true ? "true" :"false"
						};
						for (var j = 0; j < this.configValues[i].catalogEntries.length; j++) {
						    var catalogEntry = this.configValues[i].catalogEntries[j];
							arr.push({
								name: catalogEntry.name,
								typeId: catalogEntry.value
							});
						}
						object.catalogEntries = arr;
						returnArray.push(object);
					}
				}
			}
            var retVal = {
                catalogTypesJsonString: this.initialized && this.initialized == true ? dojo.toJson(returnArray) : null
            };
            return retVal;
        },
      
 		toggleMode: function()
		{			
			this.updateMode(this.isEditable()); 
		},
 
		_createCatalog: function()
		{	
		   	this.theCatalog = this.theCatalog ? this.theCatalog : new com.ibm.asq.common.web.client.internal.Catalog();
         	//initialize the catalog if necessary
			var catalog = com.ibm.asq.common.web.client.internal.Catalog;
			if (!catalog.theCatalog) {			
				var self = this;
				var callbackObj = {
					success: function(){
						self._setConfig();
					},
					failure: function(e){
						self._error(e);
					}
				};
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				this.theCatalog.initializeTemplates(responseHandler);
			} else {
				this._setConfig();
			}
		},
		
		_setConfig: function(newConfigList)
		{
			var configs =[];
			if(newConfigList)
				configs = newConfigList;
			else
				configs = this._plan ? this._plan : null;
			this._envItems = [];
			this.configValues = [];
            
            var theCatalog = this.theCatalog;
			var types = theCatalog.getDisplayTypes();

			var attributeIds = types;
            var catalogTypes = (configs && configs.catalogTypes) ? configs.catalogTypes : null;
            var catalogTypes_len = (catalogTypes) ? catalogTypes.length : 0;
			
			var typesLength = types.length;
			if(typesLength > 0 && configs && configs.catalogTypes ){
				var inInSearch = false;
				var configsLength = configs.catalogTypes.length;
				for(var i = 0; i < typesLength; i++) {
					var type = types[i];
					for(var j =0 ; j< configsLength ; j++){
						if(type.partName==configs.catalogTypes[j].name.partName){
							inInSearch = configs.catalogTypes[j].includeInSearch ;
							break; 
						}
					}
				
					var ele = { 
						catalogType: type,
						catalogEntries: [],
						includeInSearch : inInSearch 
					};
					this.configValues.push(ele);
					
					for (var j = 0; j < catalogTypes_len; j++){
						var catalogType = catalogTypes[j];
						//Fix for 21551. In 1.0.1, catalogType.name is a string type, but it's a json type in 2.0.0.1.
						//The string type name could not match the displaying code logic, so replace the string type
						//name to a json type for consistency. 
						if(catalogType.name == type.partName){
							catalogType.name = type;
						}
					}
				}
			}
			
            for (var i = 0; i < attributeIds.length; i++) {
                var displayValues = theCatalog.getValuesForDisplayType(attributeIds[i]);
                var displayValues_len = displayValues.length;
                var selectedValues = [];
                if (catalogTypes_len > 0) {
                    for (var k = 0; k < catalogTypes_len; k++) {
                        // the catalog type (name) is a json object with several
                        // fields that identifies a particular catalog type (part)
                        // that we're referencing in a test plan. They are:
                        //   obj.id - an id uniquely identifies this obj.
                        //   obj.template - the catalog's template id
                        //   obj.partName - the name of the catalog part (i.e., OperatingSystem, AIX, Browsers, etc.)
                        //   obj.partId - the id of the catalog part
                        //   obj.name - the display name for the part type.
                        // If our reference part is in the 'theCatalog', look for the part type's
                        // selected values.
                        var envType = catalogTypes[k].name;
                        if (envType.partId == attributeIds[i].partId) {
                            var values = [];
                            var catalogTypes_k_values = catalogTypes[k].values;
                            var catalogTypes_k_values_len = catalogTypes_k_values.length;
                            for (var p = 0; p < catalogTypes_k_values_len; p++) {
                            	var value_id = catalogTypes_k_values[p].id;
                                for (var j = 0; j < displayValues_len; j++) {
                                    if (value_id == displayValues[j].value) {
                                        values.push(displayValues[j]);
                                        selectedValues[j] = true;
                                        break;
                                    }
                                }
                            }
                            if (values.length > 0) {
                                this.updateData(null, values, {
                                    catalogType: envType
                                }, true);
                            }
                        }
                    }
                }
                var configObj = {
                    catalogType: attributeIds[i],
                    catalogEntries: displayValues,
                    selectedValues: selectedValues
					
                };
                if (this.configValues[i]) {
	                configObj.includeInSearch = this.configValues[i].includeInSearch;
                }
                this._envItems.push(configObj);
            }
			this._updateTabs(this._envItems); 
		},
		
		_updateTabs: function(items)
		{
			for(var i=0;i<this.tabs.length ; i++)
				this.tabs[i].appendConfig(items);
		},
		
		updateMode: function(mode)
		{
			for(var i=0;i<this.tabs.length ; i++)
			{
				this.tabs[i].updateMode(this.editable);
			}	
		},
		
		appendConfigAndUpdateTabs: function(config)
		{
			//this.config = config;
			this._setConfig();
		},
		
		_initTabContainer: function() {
			//set up the tab container (if not in print mode)
			if (!this.isPrintView()) {
				this._contentArea = new ContentAreas({
                    // don't show any scrollable tabs
                    tabNoScroll: true
                });
				this._contentArea.initialize({
					tabContainerStyle: "min-height: 100px"
				});
				
				this._tabContainer.appendChild(this._contentArea.domNode);
				
				var args = {
					name: Constants.getMessage("labelPlatformCoverage"),
					noSelect: true,
					content: this._environmentsContainer
				};
				this._contentArea.addPage(args);
				
				var args = {
					name: Constants.getMessage("labelTestEnvironment"),
					noSelect: true,
					content: this._configurationsContainer
				};
				this._contentArea.addPage(args);
			} else {
				//otherwise, for print view, add titles
				var coverageTitle = document.createElement("span");
				coverageTitle.innerHTML = Constants.getMessage("labelPlatformCoverage");
				dojo.addClass(coverageTitle, "printable-section-title");
				this._environmentsContainer.appendChild(coverageTitle);
				
                var envTitle = document.createElement("span");
                envTitle.innerHTML = Constants.getMessage("labelTestEnvironment");
                dojo.addClass(envTitle, "printable-section-title");
                this._configurationsContainer.appendChild(envTitle);				
			}
			
			//create EnvironmentList table ('Platform Coverage' tab in UI)
			var self = this;
			var tabArgs = {
				editable: this.isEditable(),
				printable: this.isPrintView(),
				includeInSearchCheckListener: dojo.hitch(this, function(rowObject, state) {
	            	this._updateIncludeInSearch(rowObject, state);  
	            }),
                changeListener: {
					context: self,
					method: self._updateEnvironment
				}                
			};
			this.envListTable = new EnvironmentListTableView(tabArgs);
			this._getTabbedViewer(this._environmentsContainer, this.envListTable);
			
			//create ConfigurationTableView table ('Test Environments' tab in UI)
			var className = "com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationTableView";
			var handler = {
				loaded: function(className){
					var constructor = dojo.getObject(className);
					var args = {
						editable: self.isEditable(),
						printable: self.isPrintView(), 
						actions: self._getConfigurationTableActions(),
                        allowSettings: true,
                        tableId: "RQM-ENV-CONFIG-TABLEVIEWER"
					};
					self.configurationTableWidget = new constructor(args);
					self._configurationsContainer.appendChild(self.configurationTableWidget.domNode);
					self._loadConfigurations();		        	
				}
			};
			jazz.core.loader.load_async("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient", function(){});
            jazz.core.loader.load_async(className, dojo.hitch(handler, "loaded", className));
			
			if (this._contentArea) {
				dojo.subscribe(this._contentArea._tabs.id + "-selectChild", this, "onTabChanged");
			}
		},
		
        onTabChanged: function(page) {
            // need to refresh the test env table when it's shown.
            if(page.title == Constants.getMessage("labelTestEnvironment") && this.configurationTableWidget)
                this.configurationTableWidget.getTableViewer().refresh();
        },
        
		/**
		 * Invokes the REST API to retrieve all configurations associated with the current test plan
		 */
		_loadConfigurations: function(){
			this.configurations = [];
			var responseHandler = null;
			if (!this.getParentEditor().isNew())
	            responseHandler = new ServiceResponseHandler(this, "_appendConfigurations", "_error");

			
			if (responseHandler != null) {
			    var args = {
	                testsPlanUUID: this.getArtifact().versionableItemId
			    }
                if (this.parentEditor.configurationItemId) {
                    args[OslcConfigParamName] = this.getParentEditor().configurationItemId;
                }
				com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient.getConfigurationsByTestPlan(responseHandler, args);			
			}
		},

		/**
		 * Appends AssetConfigurationDTO[] to local storage of configurations and refreshes table viewer
		 */		
		_appendConfigurations: function(dtos) { //AssetConfigurationDTO[]
			dtos = dtos || [];
            var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
			for (var i = 0; i < dtos.length; i++) {
				if (!dtos[i].isDeleted) {
					var config = this._fromDTO(dtos[i], catalog);
					this.configurations.push(config);
				}
			}
			this.configurationTableWidget.refresh(this.configurations);
        },
		
		_removeConfigurations: function(itemIds) {
			itemIds = itemIds || [];
			var updated = [];
			for (var i = 0; i < this.configurations.length; i++) {
				if (!this._contains(itemIds, this.configurations[i].config.id)) {
					updated.push(this.configurations[i]);
				}
			}
			this.configurations = updated;
			this.configurationTableWidget.refresh(this.configurations);
        },		
		
		_fromDTO: function(dto, catalog) { //AssetConfigurationDTO
			catalog = catalog || new com.ibm.asq.common.web.client.internal.Catalog();
			var configuration = new com.ibm.asq.common.web.client.internal._catalog.Configuration(dto.configuration);
			var attributeIds = catalog.getDisplayTypes();
			var config = [];
			for (var j = 0; j < attributeIds.length; j++) {
				var value = configuration.getValue(attributeIds[j]);
				if (value) {
					config.push({
						key: attributeIds[j],
						value: value
					});
				}
			}
			config.config = dto;
			return config;		
		},
		
		_getConfigurationTableActions: function(){
			var actions = [];

			var ewi_type_save = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_LM_TEST_ENVIRONMENT;
			var ewi_perm_save = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(ewi_type_save);
			
            if (!ewi_perm_save||ewi_perm_save.create) {
                actions.push({
                    label: Constants.getMessage("labelGenerateNewConfigurations"),
                    actionHandler: dojo.hitch(this, "_handleGenerateConfigurationClicked"),
                    iconClass: "generate-config-icon",
                    disabledOnReadOnly: true
                });
            }
            
             actions.push({
                label: Constants.getMessage("labeAddExistingConfigurations"),
                actionHandler: dojo.hitch(this, "_handleAddConfigurationClicked"),
                iconClass: "add-icon-image",
                disabledOnReadOnly: true
            });
            
			actions.push({
                label: Constants.getMessage("labelRemoveConfigurations"),
                actionHandler: dojo.hitch(this, "_handleDeleteConfigurationClicked"),
                iconClass: "remove-icon-image",
                disabledOnReadOnly: true
            });
			
			return actions;
		},
		
		_handleGenerateConfigurationClicked: function(){
			var wizardClassName = "com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGWizard";
            jazz.core.loader.load_async(wizardClassName, dojo.hitch(this, "_showCFGWizard", wizardClassName));
		},
		
		_showCFGWizard: function(wizardClassName) {
			if (!this.getParentEditor().isNew() && !this.environmentUpdated) {
				var isEmpty = true;
				for(var i = 0; i < this.configValues.length; i++){
					if(this.configValues[i].catalogEntries && this.configValues[i].catalogEntries.length > 0){
						isEmpty = false;
						break;
					}
				}
				if(!isEmpty){
					var self = this;
		            var args = {
		                parentController: self,
		                callback: {context: self, method: self._addConfigurations},
		                testPlan: this.getArtifact()
		            };
		            var constructor = dojo.getObject(wizardClassName);
		            this._ewiWizard = new constructor(args);
				}else{
					var msg = Constants.getMessage("msgNoTestEnvironments", this.getArtifactType());
					this._displayAlertDialog(msg);
					this._activateTab(0);
				}
			} else {
                var msg = Constants.getMessage("msgSaveToGenerateConfigurations", this.getArtifactType());
				this._displayAlertDialog(msg);
            }
        },
		
		_handleDeleteConfigurationClicked: function() {
			var configurations = this.configurationTableWidget.getSelectedConfigs();
			if (configurations.length == 0) {
				this._displayAlertDialog(Constants.getMessage("msgDeleteConfiguration"));
				return;
			} else {
				var msg = "";
				if (configurations.length == 1) {
					msg = Constants.getMessage("msgPromptDeleteConfiguration", configurations[0].config.name);
				}
				else if (configurations.length > 1) {
					msg = Constants.getMessage("msgPromptDeleteConfiguration1", configurations.length);
				}
				var self = this;
				var args = {
					primaryTitle: Constants.getMessage("labelConfirmation"),
					message: msg,
		            okLabel: Constants.getMessage('labelDelete'),
					okCallback: function(){   
						self._deleteConfigurations(configurations);
						return true;          
					},
					cancelCallback: function() {
						return false;
					}
				};
				var dialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);
	        	dialog.open();
			}
			
		},
		
		_deleteConfigurations: function(configurations){
			//for each item removed, remove from save context
			var itemIds = [];
			for (var i = 0; i < configurations.length; i++) {
				var itemId = configurations[i].config.id;
	            //handle item removal from save context   
	            var saveContext = this.getSaveContext();
	            if (this._contains(this._configsAdded, itemId)) {
	                //if added since last save, do 'uncreate' link from save context
	                this._configsAdded = this._remove(this._configsAdded, itemId);
	                saveContext.uncreateLink(this.getParentEditor(), LINK_TYPE_ID, itemId);
	            } else {
	                //otherwise, do 'remove' existing link from save context
	                this._configsRemoved.push(itemId);
	                saveContext.removeLink(this.getParentEditor(), LINK_TYPE_ID, itemId);
	            }		
				itemIds.push(itemId);		
			}
			this.setDirty();				
			this._removeConfigurations(itemIds);
		},			
		
		_handleAddConfigurationClicked: function() {
			if(this.getArtifact && this.getArtifact() && this.getArtifact().versionableItemId){
				if(!dojo.getObject("com.ibm.rational.test.lm.web.ui.internal.views.configurations.TESelectorDialog")){
					jazz.core.loader.load_async("com.ibm.rational.test.lm.web.ui.internal.views.configurations.TESelectorDialog", 
							dojo.hitch(this, "_handleAddConfigurationClickedAfterLoad"));
				}else{
					this._handleAddConfigurationClickedAfterLoad();
				}
	            
			} else {
				var msg = Constants.getMessage("msgSaveToAddEnvironments");
				this._displayAlertDialog(msg);
			}
		},
		
		_handleAddConfigurationClickedAfterLoad : function(){
            
            // don't show the TEs that are already added in our env 
            // list. Create the exclude list and set it to the selection
            // dialog.
            var currConfigs = [];
            var configs = this.configurations;
            var len = configs.length;
            
            // create a list of configs
            for(var i = 0; i < len; i++) {
                currConfigs.push(configs[i].config);
            }
	        this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.TESelectorDialog(
            {
                title: Constants.getMessage("labelSelectTestEnvironment"), 
                isSingleSelect: false,
                excludeList: currConfigs
            });
	        this.selectDlg.setOKAction(dojo.hitch(this, this._addConfigurationsFromDialog));
    	    this.selectDlg.show();
		},
    
		_addConfigurationsFromDialog: function() {
			var selected = this.selectDlg.getSelectedIDs() || [];
			if (selected.length > 0) {
				var responseHandler = new ServiceResponseHandler(this, "_addConfigurations", "_error");
				this._configClient.getConfigurationsWithDetails(responseHandler, selected);
			}
		},
		
	    _addConfigurations: function(configDTOs) {
			configDTOs = configDTOs || [];
			//for each item added, add to save context
			for (var i = 0; i < configDTOs.length; i++) {
				var itemId = configDTOs[i].id;
	            //handle item added to save context   
	            var saveContext = this.getSaveContext();
	            if (this._contains(this._configsRemoved, itemId)) {
	                //if removed since last save, do 'unremove' link from save context
	                this._configsRemoved = this._remove(this._configsRemoved, itemId);
	                saveContext.unremoveLink(this.getParentEditor(), LINK_TYPE_ID, itemId);
	            } else {
	                //otherwise, do 'add' existing link from save context
	                this._configsAdded.push(itemId);
	                saveContext.createLink(this.getParentEditor(), LINK_TYPE_ID, itemId);
	            }				
			}		
			if (configDTOs.length > 0) {
				this.setDirty();
				this._appendConfigurations(configDTOs);
			}
	    },
	    
	    _addPendingDeleteItemsFromMerge: function(){
	    	//For merge case, hook up the deletion of environments IF the user did not pressed merge
        	if(this.isStaleMerge && this.differencesList){
        		this._deleteConfigurations(this.environmentsDifferencesList);
        	}  
	    },
    
		_activateTab: function(tabIndex){
			if(!this._contentArea){
				console.error("this._contentArea has not been initialized.");
				return;
			}
			var tabs = this._contentArea._tabs.getChildren();
			if(tabIndex >= tabs.length){
				throw new Error(Constants.getMessage("labelTabIndex", tabIndex));
			}else{
				this._contentArea._tabs.selectChild(tabs[tabIndex]);
			}
		},
		
		_getTabbedViewer: function(node, tabContent)
		{
			this.tabs = [];
			node.appendChild(tabContent.domNode);
			this.tabs.push(tabContent);
		},
		
		updateData: function(oldValues, newValues, rowData, internal)
		{
			var configObjects =[];
			//First prepare config object to save older data
			for(var i=0; i<this.configValues.length; i++)
			{
				if(this.configValues[i].catalogType.id == rowData.catalogType.id)
				{
					this.configValues[i].catalogEntries = newValues;
				}
			}
			if(!internal)
			{
				for(var i=0; i<this.configValues.length; i++)
				{
					var obj = {name: this.configValues[i].catalogType, values: []};
					//Store the older values and overwrite if needed
					for(var count=0;count<this.configValues[i].catalogEntries.length;count++)
						obj.values[count] = {name: this.configValues[i].catalogEntries[count]};
					if(this.configValues[i].catalogType.id == rowData.catalogType.id)
					{
						obj.values = [];
						for(var j=0;j<newValues.length;j++)
							obj.values[j] = {name: newValues[j]};
						configObjects.push(obj);
					}
					configObjects.push(obj);
				}
				this._setConfig({catalogTypes: configObjects});
			}
			
		},
		
		_updateIncludeInSearch: function(rowObject,state){
			if(rowObject){
				for (var i = 0 ; i < this.configValues.length ; i++){
					if( rowObject.catalogType.id == this.configValues[i].catalogType.id){
						this.configValues[i].includeInSearch = state ;
					}
				}
				this.setDirty(true);
			}
		},
		
		_updateEnvironment: function(config)
		{
			this.configValues = config;
			this.environmentUpdated = true;
			this.setDirty();
		},
		
		_displayAlertDialog: function(message, handler)
		{
			var args = {
                'message': message
            };
			if(handler){
				args.okCallback = handler;
			}
			var alertDialog = new AlertDialog(args);
			
            alertDialog.open();
		},
		
		_compareEnvironmentsByName: function(obj1, obj2) {
			var val1 = obj1 && obj1.name ? obj1.name : "";
			var val2 = obj2 && obj2.name ? obj2.name : "";
			if(val1 == val2)
            	return 0;
        	return (val1 > val2) ? 1 : -1;
		},
		
        _contains: function(values, value) {
			values = values || [];
            for (var i = 0; i < values.length; i++) {
                if (values[i] == value) {
                    return true;
                }
            }
            return false;
        },	
		
        _remove: function(values, value){
            var updatedValues = [];
            for (var i = 0; i < values.length; i++) {
                if (values[i] != value) {
                    updatedValues.push(values[i]);
                }
            }
            return updatedValues;
        },		
		
		_error: function(e)
		{
			console.error(this.declaredClass + ": An error occurred: \n[" + e.message + "]");
		},
		
		defaultAcceptSectionContent: function(){
			//due to the special nature of this section we need to treat it independently when stale merge is called. 
			if(this.isStaleMergeInProgress()){			
				if(!this.fullyInitialized  && this.mergeRetry < 4){
					//section is fully initialized until it has fetched all the necessary info, when done let's continue with merge.
					this.mergeRetry++;
					setTimeout(dojo.hitch(this, "defaultAcceptSectionContent"), 100);
					return;
				}
				var sourceSection = this.getSourceSection();
				var remotePlan = sourceSection.getArtifact();												
				this._setConfig(remotePlan);				 				
				this.markSectionAsMerged();
			} else {
				this.inherited('defaultAcceptSectionContent', arguments);
			}
		}
	}
);
}
)();
