/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2015. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView");

dojo.require("com.ibm.asq.common.web.ui.internal.util.ConfigurationUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.client.internal.ContributorClient");
dojo.require("com.ibm.asq.common.web.client.internal.FiltersQueriesClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateField");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
              

dojo.require("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil");

dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.CategoryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.TeamAreaFilterUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.ChannelFilterUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.TimelineIterationsFilterUtil");

dojo.require("jazz.app.context");
dojo.require("com.ibm.asq.common.web.ui.internal.util.PrintHelper");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowInitialization");

dojo.require("com.ibm.rqm.process.web.client.internal.approval.ProcessClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.action.BulkChangeAction");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactSelectorPanelFormField");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.navigator.CategoryModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.NewItemPopup");
dojo.require("com.ibm.asq.common.web.client.internal.ConfigurationManagementClient");

dojo.require("jazz.core.loader");

(function() {

var ServiceResponseHandler      = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var CommonPreferenceClient		= com.ibm.asq.common.web.client.internal.CommonPreferenceClient;
var TableContentFilterProvider  = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var TableConstants              = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;

var RegistryClient              = com.ibm.rqm.planning.web.client.internal.RegistryClient;
var UserClient                  = com.ibm.asq.common.web.client.internal.ContributorClient;
var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
var FILTER_CACHE_OBJ_ID			= "com.ibm.rqm.planning.tableViews.filter.cache";
var DEFAULT_SCRIPT_TYPE         = "Manual";
var AlertDialog                 = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var GlobalEvents                = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var RiskUtil					= com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskUtil;
var FiltersQueriesClient        = com.ibm.asq.common.web.client.internal.FiltersQueriesClient;
var getCurrentPA                = jazz.app.context.get;
var PrintHelper					= com.ibm.asq.common.web.ui.internal.util.PrintHelper;
var CategoryClient              = com.ibm.rqm.planning.web.client.internal.CategoryClient;
var CategoryUtil                = com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil;
var UNASSIGNED_CATEGORY         = Constants.getMessage("labelUnassigned");

var WorkflowManager             = com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager;
var Workflowinitialization      = com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowInitialization;
var PrivateWorkflowManager      = com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.PrivateWorkflowManager;
var TimelineIterationsFilterUtil = com.ibm.rqm.planning.web.ui.internal.util.TimelineIterationsFilterUtil;
var TeamAreaFilterUtil			= com.ibm.rqm.planning.web.ui.internal.util.TeamAreaFilterUtil;
var ChannelFilterUtil			= com.ibm.rqm.planning.web.ui.internal.util.ChannelFilterUtil;
var ProcessClient				= com.ibm.rqm.process.web.client.internal.approval.ProcessClient;
var ViewHeaderLayout            = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var NoItemMessage               = Constants.getCommonMessage("tableViewer_noItemDefaultMsg");
var CategoryModel               = com.ibm.asq.common.web.ui.internal.widgets.navigator.CategoryModel;
var quickCreateArtifactPopup    = com.ibm.rqm.planning.web.ui.internal.view.construction.quickCreateArtifactPopup;
var Utility                     = com.ibm.asq.common.web.ui.internal.util.Utility;
var OslcConfigParamName         = com.ibm.asq.common.web.client.internal.Constants.OSLC_CONFIG_PARAM_NAME;
var ConfigurationUtil 			= com.ibm.asq.common.web.ui.internal.util.ConfigurationUtil;
var ConfigManagementClient      = com.ibm.asq.common.web.client.internal.ConfigurationManagementClient;

// Simple loader to load a category type's values. It caches the values to
// avoid unnecessary fetching from the server.
//

function name_sort(v1, v2)
{
    var name1 = v1.name ? v1.name.toLowerCase() : v1.name;
    var name2 = v2.name ? v2.name.toLowerCase() : v2.name;
    return (name1 > name2) ? 1 : (name1 == name2) ? 0 : -1;
};

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.table.CategoryValuesLoader", 
             null,
{
    artifactType: null,
    projectAreaItemId: null,
    model: null, // Provided by AbstractExplorableTableView
    valueParentsMap: {},
    queryFilters: null, // Query filter values will be set by SavedQueriesModelProvider when loading a query
    
    constructor: function(args) {
        dojo.mixin(this, args);    
        this.typeValuesCache = {}; 
		this.inFetchingTypes = {};
    },
    
    loadCategoryValues: function(categoryType, categoryTypes, callback) {
    	var typeItemId = categoryType.itemId;
    	
    	var parentFilteringValues = this.getParentFilteringValues(categoryType);
    	
        var cachedValues = this.typeValuesCache[typeItemId];
        if(cachedValues && !parentFilteringValues) {
            setTimeout(dojo.hitch(this, function() {
                callback(cachedValues);
            }));
            return;
        }
		// we're currently fetching the type's value. Don't try to 
		// fetch again, add it to the deferred callback list. Once we've
		// the values, we'll call all that asked for this.
		if(this.inFetchingTypes[typeItemId]) {
			var deferred = this.inFetchingTypes[typeItemId];
			deferred.push(callback);
			return;
		}
        
        // if the category type belongs in a hierarchy, show a tree for selection
        // values, otherwise, just show a flat list of values.
        // 
        if(this._isInHierarchy(typeItemId) && parentFilteringValues) {
    			this.categoriesAsList = [];
    			this._filterByParentValues(parentFilteringValues, callback, typeItemId);
        } 
        else {
        	var handler = {
                    self: this,
                    callback: callback,
                    typeItemId: typeItemId,
        			
        			handleDeferred: function(categories) {
                        var deferred = this.self.inFetchingTypes[this.typeItemId];
        				var len = deferred.length;
                        if(len) {
                            for(var i = 0; i < len; i++) {
                                deferred[i](categories);
                            }
                        }
                        delete this.self.inFetchingTypes[this.typeItemId];				
        			},
                    success: function(categoriesDTO) {
                    	var categories = [];
                    	dojo.forEach(categoriesDTO, function(item) {
                    		categories.push(CategoryUtil.cleanupCategoryValueDTO(item));
                    	});
                        var catsLen = categories && categories.length;
                        if (catsLen > 0) {
                            categories = categories.sort(name_sort);
                            // add the unassigned option if there is any categories defined in this category type
                            categories.unshift({
                                name: UNASSIGNED_CATEGORY,
                                itemId: "Unassigned",
                                categoryType: {
                                    itemId: this.typeItemId
                                },
                                checked: false
                            });
                        }
                        this.self.typeValuesCache[this.typeItemId] = categories;
                        this.callback(categories);
        				this.handleDeferred(categories);

                    },
                    error: function(e) {
                        this.callback(null);
        				this.handleDeferred(null);
                    }
                };
    		this.inFetchingTypes[typeItemId] = [];
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            CategoryClient.getCategories(responseHandler, typeItemId, this.artifactType, false, this.projectAreaItemId);
        }
		
    },
    
    // Clear all child category filters when a parent selection has been made. Additionally, mark all those child filters to force reload of values
    clearChildFilters: function(catType, oldValue, newValue) {
    	// Two scenarios here: oldValue containing more items than newValue means an item has been unchecked, so its children need to be cleared.
    	// oldValue containing less items than newValue means a new item has been checked. Nothing to clear but child filters need to be refreshed.
    	var previousValuesCount = oldValue ? oldValue.length : 0;
    	var newValuesCount = newValue ? newValue.length : 0;
    	var doClearChildFilters = previousValuesCount > newValuesCount;
    	
    	var childFilters = [];
    	this._getChildFilters(catType, childFilters);
    	if(childFilters.length > 0) {
    		if(doClearChildFilters) {
    			if(newValuesCount == 0){
        			this.clearAllChildValuesFromFilters(childFilters);
        		} else {
	    			var valueRemoved = this.getValueRemoved(oldValue, newValue);
	    			this.clearChildValuesFromFilters(valueRemoved, childFilters);
        		}
    		}
    		this.clearCascadeFiltering(childFilters);
    	}
    },
    
    clearChildValuesFromFilters: function(parentValue, childFilters) {
    	var selectedFilters = this.headerRenderer.getSelectedFilters() || {};
    	var length = childFilters.length || 0;
    	for(var i = 0; i < length; i++){
    		var childFilter = childFilters[i];
    		var selectedValues = selectedFilters[childFilter] || [];
    		var selectedLen = selectedValues.length;
    		var newSelected = [];
    		var containsUnassignedValue = false;
    		if(selectedLen > 0) {
    			for(var j = 0; j < selectedLen; j++) {
    				var selectedValue = selectedValues[j];
    				if(selectedValue == UNASSIGNED_CATEGORY){
    					containsUnassignedValue = true;
    					continue;
    				}
    				var parentValues = this.valueParentsMap[selectedValue];
    				//Check if selected value has the removed value as parent
    				var position = dojo.indexOf(parentValues, parentValue);
    				if(position < 0) { // Parent is NOT removed; let's make this value remain selected
    					newSelected.push(selectedValue);
    					//selectedValues.splice(dojo.indexOf(selectedValues, selectedValue), 1);
    				}
    			}
    		}
    		//only leave unassigned value for a filter if filter contains any other filter value also.
			if(newSelected.length > 0 && containsUnassignedValue){
				newSelected.push(UNASSIGNED_CATEGORY);
			}
    		this.headerRenderer.setFilterValues(childFilter, newSelected);
    	}
    },
    
    /*Useful for deleting all subvalues, unassigned value included; when last parent has been unselected. */
    clearAllChildValuesFromFilters: function(childFilters) {
    	var length = childFilters.length || 0;
    	for(var i = 0; i < length; i++){
    		var childFilter = childFilters[i];
    		this.headerRenderer.setFilterValues(childFilter, []);
    	}
    },
    
    getValueRemoved: function(biggerArray, smallerArray) {
    	var length = biggerArray.length || 0;
    	for(var i = 0; i < length; i++) {
    		var value = biggerArray[i];
    		if(dojo.indexOf(smallerArray, value) < 0)
    			return value;
    	}
    },
    
    // Connect the load function with the corresponding event
    clearCascadeFiltering: function(filters) {
    	var isAnArray = dojo.isArray(filters);
    	if(isAnArray) {
    		var len = filters.length;
	    	for(var i = 0; i < len; i++) {
	    		var filter = filters[i];
				this._forceFilterReload(filter);
			}
    	} else {
    		for(var name in filters) {
    			if(name.indexOf('categories') >= 0 && filters[name]) {
    				this._forceFilterReload(name);
    			}
    		}
    	}
    },
    
    _forceFilterReload: function(filterName) {
    	var selectedFilters = this.headerRenderer.getSelectedFilters() || {};
    	// Set previously selected values as defaults for reload
    	var previousValues = selectedFilters[filterName] || [];
    	var filterWidget = this._getFilterWidget(filterName);
		if(!filterWidget.dropDownTriggerLoad) {
			filterWidget.defaultValue = previousValues;
			filterWidget.dropDownTriggerLoad = filterWidget.connect(filterWidget.toggleFilter, "openDropDown", "_dropDownOpenTrigger");
		}
    },
    
    _getFilterWidget: function(filterName) {
    	// Check first if the filter widget is on a visible column
    	var widget = this.headerRenderer.filterCtrls[filterName];
    	if(widget)
    		return widget;
    	var moreCtrls = this.headerRenderer.moreFiltersCtrl.fields;
    	var len = moreCtrls.length;
    	for(var i = 0; i < len; i++) {
    		var ctrl = moreCtrls[i];
    		if(ctrl.fieldName == filterName)
    			return ctrl;
    	}
    },
    
    _getChildFilters: function(catType, childFilters) {
    	if(!catType.childType || catType.childType.length == 0)
    		return childFilters;
    	
    	var childTypes = catType.childType; // Multi Sub Categories
    	var len = childTypes.length;
    	for(var i = 0; i < len; i++) {
    		var childTypeId = childTypes[i];
    		childFilters.push('categories' + childTypeId);
    		this._getChildFilters(this._getCategoryType(childTypeId), childFilters);
    	}
    },
    
    _isInHierarchy: function(typeItemId){
    	var isInHierarchy = false;
    	var categoryType = this.model.getCategoryTypeById(typeItemId);
        if(!categoryType){
        	if(this.parentModel){
	        	categoryType = this.parentModel.getCategoryTypeById(typeItemId);
	        	if(categoryType){
	        		isInHierarchy =  this.parentModel.isInHierarchy(typeItemId);
	        	}
        	}
        }else{
        	isInHierarchy =  this.model.isInHierarchy(typeItemId);
        }
        return isInHierarchy;
    },
    
    _getCategoryType: function(typeItemId){
    	var categoryType = this.model.getCategoryTypeById(typeItemId);
        if(!categoryType && this.parentModel){
        	categoryType = this.parentModel.getCategoryTypeById(typeItemId);
        }
        return categoryType;
    },
    
    _getCategoryValueById: function(category){
    	var categoryId = category;
    	if(typeof category === 'object'){
    		categoryId = category.itemId;
    	}    	
    	var category = this.model.getCategoryValueById(categoryId);
        if(!category && this.parentModel){
        	category = this.parentModel.getCategoryValueById(categoryId);
        }
        return category;
    },
    
    _getCategorySubValues: function(item, handler, /*Optional*/ specificChildCatTypeId){
        var typeItemId = item.typeItemId;
        var categoryType = this.model.getCategoryTypeById(typeItemId);
        if(!categoryType){
        	if(this.parentModel){
        		categoryType = this.parentModel.getCategoryTypeById(typeItemId);
	        	if(categoryType){
	        		this.parentModel._getCategorySubValues(item, handler, /*Optional*/ specificChildCatTypeId);
	        	}
        	}
        }else{
        	this.model._getCategorySubValues(item, handler, /*Optional*/ specificChildCatTypeId);
        }
        
    },
    
    _filterByParentValues: function(parentFilteringValues, callback, currentCatTypeItemId) {
    	if(parentFilteringValues.length == 0) {
    		var styledList = [];
    		dojo.forEach(this.categoriesAsList, function(item) {
    			if(item.currentCatTypeItemId == currentCatTypeItemId && !item.itemLabel) {
    				item.name = " ... " + item.name;
    			}
    			if(item.currentCatTypeItemId == currentCatTypeItemId){
    				styledList.push(item);
    			}
    		});
    		callback(styledList);
    	} else {
    		var parentCatValue = this._getCategoryValueById(parentFilteringValues.shift());
    		if(parentCatValue) { 
	    		this.categoriesAsList.push({
		    			itemLabel:true,
		    			name:parentCatValue.name,
		    			itemId:parentCatValue.name,
		    			currentCatTypeItemId : currentCatTypeItemId,
		    			isCategoryParentValue: true
		    		});
				this._getCategorySubValues(parentCatValue, dojo.hitch(this, function(valuesTemp) {
					// add the unassigned option if there is any categories defined in this category type
					if(valuesTemp) {
						if(!parentCatValue.childValues){
							parentCatValue.childValues = [];
						}						
						var values = [];
						dojo.forEach(valuesTemp, function(value) {							
							var item = CategoryUtil.cleanupCategoryValueDTO(value);							
							item.currentCatTypeItemId = currentCatTypeItemId;
							item.parentValueItemId = parentCatValue.itemId;
							item.parentCatTypeItemId =  parentCatValue.typeItemId;
							values.push(item);
							parentCatValue.childValues.push(item.name);
						});
		                values.unshift({
		                    name: UNASSIGNED_CATEGORY,
		                    itemId: "Unassigned",
		                    categoryType: {
		                        itemId: this.typeItemId
		                    },
		                    checked: false,
		                    currentCatTypeItemId : currentCatTypeItemId
		                });
						this.categoriesAsList = this.categoriesAsList.concat(values);
						// Create a map of type valueItemId => [parentValueItemIds] to handle filter updating
						var valuesLength = values.length;
						for(var i = 0; i < valuesLength; i++) {
							var valueItemId = values[i].itemId;
							if(valueItemId == "Unassigned")
								continue;
							var parentValues = this.valueParentsMap[valueItemId];
							if(!parentValues) {
								parentValues = [];
							}
							var parentItemId = parentCatValue.itemId;
							parentValues.push(parentItemId);
							if(this.valueParentsMap[parentItemId]) { // If parent value also has parents, include them for this child
								parentValues = parentValues.concat(this.valueParentsMap[parentItemId]);
							}
							this.valueParentsMap[valueItemId] = parentValues;
						}
					}
					this._filterByParentValues(parentFilteringValues, callback, currentCatTypeItemId);
				}), currentCatTypeItemId);
    		}
    	}
    },
    
    // Look for specific values set on the parent category filter
    getParentFilteringValues: function(categoryType) {
		// Look first for queryFilters, then for filter values coming from the header	
    	var previousFilters = this.queryFilters || this.headerRenderer.getSelectedFilters(true) || {};
			
			var parentFilteringValues = previousFilters['categories' + categoryType.dependsOn]; // Key for the "parent" filter values selected
			if(!parentFilteringValues && categoryType.dependsOn){
				parentFilteringValues = previousFilters['parentCategories' + categoryType.dependsOn]; // Key for the "parent" filter values selected
			}
			if(parentFilteringValues) {
				// In case there is only the unassigned value as selected, dismiss it
				if(parentFilteringValues.length == 1 && parentFilteringValues[0] == UNASSIGNED_CATEGORY)
					return null;
				return dojo.clone(parentFilteringValues);
			}
			return null;
    },
    
    // model's provider method to return the category values for a category type
    getRootTypeCategoryValues: function(item, onComplete)
    {
        var handler = {
            onComplete: onComplete,
            success: function(categoriesDTO) {
                this.onComplete(categoriesDTO);
            },
            failure: function() {
                this.onComplete([]);
            }
        };
        var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
        CategoryClient.getCategories(responseHandler, item.itemId, this.artifactType, /* don't show archived */false);               
    },
    
    // model's provider method to return the constraint children category values given a parent category value item 
    subCategoryValuesProvider: function(childCategoryTypes, item, onComplete)
    {
        var handler = {
            onComplete: onComplete,
            success: function(categoriesDTO) {
                this.onComplete(categoriesDTO);
            },
            failure: function() {
                this.onComplete([]);
            }
        };
        var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
        CategoryClient.getCategoryValues(responseHandler, childCategoryTypes, item.itemId);        
    }

});

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView", null,
{
    // optionally to pass in 'hidden' query parameters to constrain the results to
    // the specified parent artifact. The name is the query argument name to be 
    // used in the query. It requires a matching itemId for the argument's value.
    // These attributes can be array as well, if more then one 'parent' constraining 
    // artifacts are needed. The order of the argument & value array must match.
    //
    parentItemIdArgName: null,
    parentVersionItemId: null,
    parentItemArgName: null,
    parentItemArgValue: null,
    relatedTestCaseItemId: null,
    relatedTestPlanItemId: null,
    //saves a date object of the latest request created
    lastRequestTimestamp:null,
    // Specify a non-default project area context for the artifact list
    projectAreaContext: null,
    projectItemId: null,
    
    // By default, whenever a new query is made, the selection needs to
    // cleared. Use this flag to override this behavior. However, only in
    // the context of in-line selector should use this flag.
    clearSelectionOnQuery: true,
    
    // If true then the table's sort, group, and filters will be automatically
    // persisted in a saved query any time that a new query result is shown.
    // Also if enabled then the autosaved query will automatically run when
    // the table is initialized.  By default autosave will be enabled when
    // the table is in a picker.
    _autoSaveEnabled: null,
    
    // Set this attribute to initially select a set of rows. The selection
    // will apply once when the initial content is first shown
    initialSelectedRows: null,
    
    // force the filter area to open in table viewer
    openFilterArea: false,
    
    // compose a hidden arguments array for lookup
    hiddenArgs: {
        parentItemIdArgName: null,
        parentVersionItemId: null,
        relatedTestCaseItemId: null,
        relatedTestPlanItemId: null,
        parentItemArgName: null,
        parentItemArgValue: null
    },
    editable: true,
    enableRowEditable: true,
    
	constructor: function() {
		this._typeLabel = "";
		this._searchFunction = null;
		this._searchCallback = null;
		this._searchFilterCallback = null; //allow caller to provide additional filter
		this._searchResponseHandlerType = ServiceResponseHandler;
        this._processDateTimeFilter = false; // default to not process time-based filtering unless
                                             // the filter is added and opt to process the params
		this.resultLimit = -1;				// allow default resultLimit
		//get the required user preferences
		var initOpenPref = CommonPreferenceClient.getStoredUserPreferences(
			Constants.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY.key
		);
		this._initiallyOpen = initOpenPref && !dojo.isArray(initOpenPref) && initOpenPref.value == true;
		
		var runOnOpenPref = CommonPreferenceClient.getStoredUserPreferences(
			Constants.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY.key
		);
		this._runOnOpen = runOnOpenPref && !dojo.isArray(runOnOpenPref) && runOnOpenPref.value == true;
        
        // initialize whether the user has project admin permission. This is
        // to enable project default saving of the table settings.
        this.userIsProjectAdmin = (dojo.getObject(Constants.IS_PROJECT_AREA_ADMIN) == true);
        
	    // filter args to use when none have been specified
   		this._defaultFilterArgs = {                
        	includeCustomAttributes: true, 
	        includeArchived: false
    	};
   		
   		// initialize whether we're in a read only configuration
   		this._readOnlyConfig = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil.isConfigurationContextReadOnly();
	},
	
    postMixInProperties: function()
    {
        // there are non-changeable hidden filter arguments set to the viewer. 
        // save it and always have to honor when running a query.
        if(this.initFilterArgs) {
            var staticFilters = {};
            var haveHiddenFilter = false;
            for (var name in this.initFilterArgs) {
                // only taking hidden arguments to be static
                if (name in this.hiddenArgs) {
                    staticFilters[name] = this.initFilterArgs[name];
                    haveHiddenFilter = true;
                }
            }
            if (haveHiddenFilter) {
                this.staticFilterArgs = dojo.clone(staticFilters);
            }
        }
        // initialize the project area's itemId
        if (this.projectAreaContext && this.projectAreaContext.itemId) {
            var defaultPA = jazz.app.context.get();

            // we are using a non-default project area context. We
            // will use the non-default project area itemId. Make an
            // indication that this is remote content.
            //
            this.isRemote = !defaultPA || (defaultPA && (defaultPA.itemId != this.projectAreaContext.itemId));
            this.projectAreaItemId = this.projectAreaContext.itemId;
            if (this.projectAreaContext.rootUrl) {
                this.rootUrl = this.projectAreaContext.rootUrl;
            }
            
            // we have a non-default project area context. Create a private workflow manager
            // to access that context.
            this.workflowManager = new PrivateWorkflowManager({
                projectAreaItemId: this.projectAreaItemId
            });
        }
        
        if (this._autoSaveEnabled == null) {
        	this._autoSaveEnabled = this.isInPicker;
        }
        // disable edit capabilties if we're in a read only configuration
        if(this._readOnlyConfig) {
        	this.enableRowEditable = this.editable = false;
        }
    },
    
    // If we are using a non-default project area context, we need to get the PLE settings for any
    // service to use instead of using the default PLE settings of the default project area.  These
    // are async calls to check if the project area is PLE anabled and to get the configuration.
    //
    _setProjectPle: function(callback) {
        if (this.isRemote) {
            // specified project area is not the default project area, get the PLE enabled settings
            ConfigurationUtil.isProjectPleEnabled(this.projectAreaItemId, dojo.hitch(this, function(isEnabled) {
                this.isProjectPleEnabled = isEnabled;
                if (!isEnabled) {
                    // explicitly set to not using GC
                    this.gcConfigValue = null;
                }
                this._setProjectConfig(callback);
            }), dojo.hitch(this, function(error) {
                this._setProjectConfig(callback);
            }));
        } else {
            this.isProjectPleEnabled = ConfigurationUtil.isPleEnabled();
            callback();
        }
    },
    
    // Set the local configuration of the project area.  Opted out project area has a default
    // configuration as well.
    //
    _setProjectConfig: function(callback) {
        if (!this.isRemote || !this.projectAreaItemId) {
            // double check - do not need to do this if the project area is the default project area
            callback();
            return;
        }
        var handler = {
            success: dojo.hitch(this, function(configs){
                if (configs && configs.length) {
                    this.configurationItemId = configs[0].itemId;
                }
                callback();
            }),
            failure: dojo.hitch(this, function(e) {
                // console.debug(e);
                callback();
            })
        };
        var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
        ConfigManagementClient.getDefaultConfiguration(responseHandler, this.projectAreaItemId);
    },
    
	isInitiallyOpen: function() {
		return this.openFilterArea || (this._initiallyOpen && this.isQueryPage);
	},
    setTypeLabel: function(/* String */ label) {
        this._typeLabel = label;
    },  
		
	setSearchFunction: function(/* Function */ func) {
		this._searchFunction = func;
	},	
	
    setSearchCallback: function(/* Function */ func) {
        this._searchCallback = func;
    }, 

    setSearchFilterCallback: function(/* Function */ func) {
        this._searchFilterCallback = func;
    },
	
    setResponseHandlerType: function(/* TransportServiceResponseWrapper */ handlerType) {
        this._searchResponseHandlerType = handlerType || ServiceResponseHandler;
    },  
		
    setInProgress: function(msg) {
        if (this.viewHeaderNode) {
			this.viewHeaderNode.setProgressStart(msg);
		}
    },
    
    stopInProgress: function() {
        this.showInitLoadProgress = false;
		if (this.viewHeaderNode) {
			this.viewHeaderNode.setProgressEnd();
		}
		if (this.tableViewer) {
			this.tableViewer.endLoadingProgress();
		}
    },	
	
    // NOTE: Remove the use of in-session cached filters. Saved queries replaces this
    // solution.
	cacheFilters: function(filterArgs) {
        return;
        /*
		var filterCache = dojo.getObject(FILTER_CACHE_OBJ_ID);
		if (filterCache == null) {
			filterCache = {};
		}
		filterCache[this._getCacheId()] = filterArgs;
		dojo.setObject(FILTER_CACHE_OBJ_ID, filterCache);
		*/
	},
	
    // NOTE: Remove the use of in-session cached filters. Saved queries replaces this
    // solution.
	getCachedFilters: function() {
        return null;
        /*
		var filterCache = dojo.getObject(FILTER_CACHE_OBJ_ID);
		if (filterCache != null) {
			return filterCache[this._getCacheId()];
		}	
		return null;	
		*/
	},
	
    // Summary:
    // Store value as a User preference associated with the current table view.
	//
    setUserPreference: function(name, value){
        if (this.tableId){
            if (!this._viewSettings) {
                this._viewSettings = {};
            }
            this._viewSettings[name] = value;
            var settingsJson = dojo.toJson(this._viewSettings);
            var pref = {
                key: this.tableId + "-view",
                value: settingsJson
            };
            var handler = {
                success: function(response){
                },
                failure: function(e){
                    console.debug("Failed saving user table view preference.");
                }
            };
            var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
            CommonPreferenceClient.mergeAndSaveUserPreferences(pref, responseHandler);
        } else {
            console.debug("Failed saving user table view preference. A tableId is required.");
        }
    },
    
    // Summary:
    // Get the User preference stored with the current table view.
    //
    getUserPreference: function(name, value){
        if (this.tableId){
            if (!this.isPrefenceInit){
                var pref = CommonPreferenceClient.getStoredUserPreferences(this.tableId + "-view");
                if (pref && pref.value) {
                    try{
                        this._viewSettings = dojo.fromJson(pref.value);
                    } catch (e){
                        console.debug("Invalid user table view preference retrieved.");
                    }
                }
                this.isPrefenceInit = true;
            }
            if (this._viewSettings) {
                return this._viewSettings[name];
            }
        } else {
            console.debug("Failed retrieving user table view preference. A tableId is required.");
        }
        return null;
    },
	
	_getCacheId: function() {
		var table = this.tableViewer;
		return table && table.tableId ? table.tableId : this.declaredClass;
	},
	
    _getCategoryFilters: function(cacheFilters) {
        var allCatValues = [];
        
        if (cacheFilters) {
            for (var i = 0; i < cacheFilters.length; i++) {
                var filters = cacheFilters[i];
                // all of the selected values are collapsed into a comma
                // separated string.
                if (filters && filters.length > 0) {
                    allCatValues = allCatValues.concat(filters.split(","));
                }
            }
        }   
        return allCatValues;
    },
    
    _mapFilterNameToCachedValues: function(fname, cache, cachedCategories){
        // saved category filters are collapse into a single
        // value, just map any category filter to it.
        if (fname.indexOf("categories") == 0) {
            return cachedCategories;            
        }
        // the weight filter is mapped to two values
        // in the saved query, convert it back to the
        // filter consumeable default value.
        if(fname == "weight") {
            var val = cache["weightValue"];
            var op = cache["weightComparator"];
            
            if(val) {
                return {'value': val, 'operator': op || null};
            }
        }else if(fname == "estimate") {
            var val = cache["estimateValue"];
            var op = cache["estimateComparator"];
            
            if(val) {
                return {'value': val, 'operator': op || null};
            }
        }else if(fname == "timeSpent") {
            var val = cache["timeSpentValue"];
            var op = cache["timeSpentComparator"];
            
            if(val) {
                return {'value': val, 'operator': op || null};
            }
        }
        // no special mapping. 
        return cache[fname];
    },
    
    _constructTableContentProvider: function() {
        // sub-class must provide implementation to to construct
        // the table viewer's content provider.
        console.debug("_constructTableContentProvider - sub-class must provide implementation!");    
    },
    
	initFilterProvider: function(provider) {
        this.queryFilterProvider = provider;
        provider.isInSection = this.isInSection;
        provider.isInPicker = this.isInPicker;
        
		var cache = this.getCachedFilters();
		if (cache != null) {
            // the category filters are all collapsed into a single value
            // in 'categories'. Process it once to get all of the default
            // values in each of the categories.
            var cachedCategories = this._getCategoryFilters(cache["categories"]);
			var filters = provider.getFilters() || [];
            
			for (var i = 0; i < filters.length; i++) {
				var f = filters[i];
                var defaultVal = this._mapFilterNameToCachedValues(f.name, cache, cachedCategories);
                
                // no cached values, no default values to set.
				if (defaultVal == null) {
					continue;
				}
				switch(f.type) {
					case TableContentFilterProvider.FIELD_TOGGLELIST:
                    case TableContentFilterProvider.FIELD_TRUNCATED_TOGGLELIST:
                        // If any of this category values is in the filter list
                        // those values are the default values. Set them as the
                        // default values. Toggle list takes a list of values
                        // as defaults.
						if (defaultVal.length > 0 && f.params && f.params.options) {
                            var optDefaults = [];
							for (var j = 0; j < f.params.options.length; j++) {
								if (this._findIn(defaultVal, f.params.options[j].value) != null) {
									optDefaults.push(f.params.options[j].value);
								}
							}
                            f.defaultValue = optDefaults;
						}
						break;
						
					default:
						//set the default directly
						f.defaultValue = defaultVal;
						break;
				}
			}
		}
		
	},
	
	_findIn: function(array, value) {
		for (var i = 0; i < (array || []).length; i++) {
			if (array[i] == value) {
				return array[i];
			}
		}
		return null;
	},
    
    _sanitizeQueryArgs: function(filterArgs){
        // ensure the artifact id, if in the filters, is a non-zero numeric value
        if (filterArgs.id != null) {
            var idNum = Number(filterArgs.id);
            if (isNaN(idNum) || idNum <= 0) {
                delete filterArgs.id;
            }
        }
		// for comparator type id filter
		// ensure the artifact id, if in the filters, is a non-zero numeric value
		if (filterArgs.idValue != null) {
            var idNum = Number(filterArgs.idValue);
            if (isNaN(idNum) || idNum < 0 || filterArgs.idValue == "") {
                delete filterArgs.idValue;
                if (filterArgs.idComparator) {
                    delete filterArgs.idComparator;
                }
            }
        }
        // ensure the calculated risk, if specified, is numeric and not less than zero
        if (filterArgs.calculatedRisk != null) {
            var riskNum = Number(filterArgs.calculatedRisk);
            if (isNaN(riskNum) || riskNum < 0) {
                delete filterArgs.calculatedRisk;
            }
        }
        // ensure the communityRisk risk, if specified, is numeric and not less than zero
        if (filterArgs.communityRisk != null) {
            var riskNum = Number(filterArgs.communityRisk);
            if (isNaN(riskNum) || riskNum < 0) {
                delete filterArgs.communityRisk;
            }
        }
        // empty suspect is 'any' don't pass in any value to the query.
        if (filterArgs.suspect === "") {
            delete filterArgs.suspect;
        }
        
        if (filterArgs.weightValue != null) {
            // weight is defined, validate it is numeric value, empty string
            // means 'any' don't send any query parameter for that.
            var weightNum = Number(filterArgs.weightValue);
            if (isNaN(weightNum) || weightNum < 0 || filterArgs.weightValue == "") {
                // invalid weight is specified, remove corresponding args
                delete filterArgs.weightValue;
                if (filterArgs.weightComparator) {
                    delete filterArgs.weightComparator;
                }
            }
        }
        
        if (filterArgs.estimateValue != null) {
            var estimateNum = Number(filterArgs.estimateValue);
            if (isNaN(estimateNum) || estimateNum < 0 || filterArgs.estimateValue == "") {
                delete filterArgs.estimateValue;
                if (filterArgs.estimateComparator) {
                    delete filterArgs.estimateComparator;
                }
            }
        }
        
        if (filterArgs.timeSpentValue != null) {
            var timeSpentNum = Number(filterArgs.timeSpentValue);
            if (isNaN(timeSpentNum) || timeSpentNum < 0 || filterArgs.timeSpentValue == "") {
                delete filterArgs.timeSpentValue;
                if (filterArgs.timeSpentComparator) {
                    delete filterArgs.timeSpentComparator;
                }
            }
        }
        
        // make sure that we include these initial filters args, if the
        // user turn off auto run (initRunQuery not called), these args would 
        // not be included 
        
        if (filterArgs.includeCustomAttributes == undefined) {
            filterArgs.includeCustomAttributes = true;
        }
        if (filterArgs.includeArchived == undefined) {
            filterArgs.includeArchived = false;
        }
        return filterArgs;
    },
    
    // Base method to prepare the query arguments
    // 
    _prepareQueryArgs: function(filterArgs, updatePageOnly) {
        if (filterArgs != null) {
            filterArgs = this._sanitizeQueryArgs(filterArgs);
            // save the new filter args
            //cache current filter settings (session persistence of filters)
            this.filterArgs = filterArgs;
            this.cacheFilters(this.filterArgs);
        }
        else {
            // no new filter args. just use the current one. But if the list
            // was not configured to run initially, the filters args would be
            // null. Need to initialize it.
            if(!this.filterArgs) {
                this.filterArgs = this._initFilterArgs();
            }
            filterArgs = this.filterArgs;
        }
        
        // add the view specified project area or the current project area to the args
        filterArgs.processArea = this.projectAreaItemId || getCurrentPA().itemId;
        // add the view specified gc or the default gc to the args unless the project is opted out
        var gc = (this.gcConfigValue || this.gcConfigValue === null) ? this.gcConfigValue : ConfigurationUtil.getGlobalConfigValue();
        // this.gcConfigValue can be explicitly set to null if the project is opted out so don't add the gc to the args
        if (gc) {
        	filterArgs.gcConfigValue = gc;
        }
        
        if (this.includeSnapshots) {
        	filterArgs.includeSnapshots = this.includeSnapshots;
        }
        
        // If we have a parent item arg & itemId, use that to constraint our
        // query.
        if(this.parentItemIdArgName && this.parentVersionItemId) {
            // the parent item id queries can be more then one. process 
            // the multiple case too.
            if (dojo.isArray(this.parentItemIdArgName)) {
                if(dojo.isArray(this.parentVersionItemId) && 
                   this.parentVersionItemId.length == this.parentItemIdArgName.length) {
                    for(var i = 0; i < this.parentItemIdArgName.length; i++) {
						if(this.parentVersionItemId[i])
                        	filterArgs[this.parentItemIdArgName[i]] = this.parentVersionItemId[i];
						else{
							delete(filterArgs[this.parentItemIdArgName[i]]);
                    	}
	                }
                }
                else {
                    // log an error about mismatch parent parameter settings. 
                    console.error("The number of constrain artifact names does not match the number of artifact item id values");
                }
            }
            else {
                filterArgs[this.parentItemIdArgName] = this.parentVersionItemId;
            }
            if(this.parentItemArgName && this.parentItemArgValue) {
                filterArgs[this.parentItemArgName] = this.parentItemArgValue;
            }
            // there's related parent/child filter arg set. set the filter query
            if(this.parentChildArgName && this.parentChildArgValue) {
                filterArgs[this.parentChildArgName] = this.parentChildArgValue;
            }
        }else if(this.parentItemIdArgName && this.parentVersionItemId == null)
			delete(filterArgs[this.parentItemIdArgName]);                

        // applies static non-changeable filters if it was set.
        if(this.staticFilterArgs) {
            dojo.mixin(filterArgs, this.staticFilterArgs);
        }
        // apply view mode flag
        var isTraceabilityView = this.hasTraceabilityColumns();
        filterArgs.traceabilityViewType = isTraceabilityView;

        // don't include the artifact's attributes (categores, custom attributes, priority, etc.) in the DTOs, if
        // we are in selector mode. We only show the name.
        if(this.tableViewer.trim == TableConstants.TRIM_INLINE_SELECTOR) {
            filterArgs.resolveAttributes = false;
        }
        
        // re-map composite filter params if there is any
        return this._remapQueryArgs(this.filterArgs);
    },
    
    // Abstract method to be implemented by sub classes to indicate whether the current view has traceability
    // columns. Return true to fetch traceability data for the query.
    //
    hasTraceabilityColumns: function() {
        return false;  
    },
    
    // For filters with composite parameters, the server API would expect more than one parameters.
    // We need to cache the filter for persistence but have to re-map the single filter parameter
    // to multiple query parameters to satisfy the server API.  Take the modified time for example, the
    // composite filter parameter is re-mapped to "from" and "to" parameters before submitting the query.
    //
    _remapQueryArgs: function(cachedFilterArgs) {
        var filterArgs = cachedFilterArgs;
        
        // setup time-based filter params if filter is added and set to process dates with all required keywords
        if (this._processDateTimeFilter && this._dateTimeFilterKey && this._dateTimeFromFilterKey && this._dateTimeToFilterKey) {
            if (cachedFilterArgs[this._dateTimeFilterKey] != null) {
                filterArgs = dojo.clone(cachedFilterArgs);

                // apply the date time filter if defined
                var dateTimeFilter = filterArgs[this._dateTimeFilterKey];
                var from = dateTimeFilter.fromDateTime;
                var to = dateTimeFilter.toDateTime;
                var relativeUnit = dateTimeFilter.relative;
                
                if (relativeUnit) {
                    // For relative date time, the from value is the number of the time unit.
                    // The method getRelativeDateTime returns the "from" date time relative to now.
                    from = com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateField.getRelativeDateTime(dateTimeFilter);
                }
                if (from) {
                    filterArgs[this._dateTimeFromFilterKey] = from;
                }
                if (to) {
                    filterArgs[this._dateTimeToFilterKey] = to;
                }
                delete filterArgs[this._dateTimeFilterKey];
            }
        }
        
        //Custom attributes methods
        var strCustomAttributes = [];
        var intCustomAttributes = [];
        var timeCustomAttributes = [];
        var length = (this.customAttributes && this.customAttributes.length)?this.customAttributes.length:0;
        for(var i=0; i < length; i++){   
        	var filterId = (this.customAttributes[i] && this.customAttributes[i].filterId)? this.customAttributes[i].filterId:"";        	
        	var tempAttr = filterArgs[filterId];
        	var isDate = (filterId.indexOf("DATE")!= -1);
        	var isInt = (filterId.indexOf("INT")!= -1);
        	if(tempAttr && 
        		 ((isDate && (tempAttr.fromDateTime > 0 || tempAttr.toDateTime > 0)) ||
        		  (isInt && tempAttr.value && tempAttr.value!="") || 
        		  (!isDate && !isInt && ( tempAttr!="")))) {        		
        		
	          	//Custom attribute found! and it's not blank
	            //formatting for custom attributes should be: "customFilter-identifier-holder-///" + type(INT, STRING, DATE) + "///"+ itemId        	
	            var cut = filterId.split("///");
	            if(cut && cut.length==3){
	            	if(cut[1] == "STRING")
	            		strCustomAttributes.push(cut[2]+":"+tempAttr);
	            	else if (cut[1] == "INT")
	            		intCustomAttributes.push(cut[2]+":"+tempAttr.operator+":"+tempAttr.value);
	            	else if (cut[1] == "DATE"){ //?            		
	            		if(tempAttr && tempAttr.relative){
	            			var currentDate = new Date();    
	            			var otherDate = this._transformrelativeToLongDate(currentDate,tempAttr);
	            			timeCustomAttributes.push(cut[2]+":"+otherDate+":"+currentDate.getTime());
	            		}
	            		else                				
	            			timeCustomAttributes.push(cut[2]+":"+tempAttr.fromDateTime+":"+tempAttr.toDateTime);            			           			
	            	}
	            	
	        	}
        	}
        	if(filterId && filterId!="")
        		delete filterArgs[filterId];
         }        
         if(strCustomAttributes.length > 0)
        	 filterArgs["strCustomAttributes"] = strCustomAttributes;
         if(intCustomAttributes.length > 0)
        	 filterArgs["intCustomAttributes"] = intCustomAttributes;
         if(timeCustomAttributes.length > 0)
        	 filterArgs["timeCustomAttributes"] = timeCustomAttributes;         
                         
        return filterArgs;
    },
    
    _addCustomAttributesFilterSupport: function(originalFilters){    
    	var filters = originalFilters;
    	var length = (this.customAttributes && this.customAttributes.length)?this.customAttributes.length:0;      
        for(var k = 0; k < length; k++){
        	var currentAttribute = this.customAttributes[k];
        	var name = "";
        	var title = "";            
        	var holder = "";
               
           	name = currentAttribute.name;
           	title = currentAttribute.name;      
           	
           	var filter  = {
           				dbName: name,  
                        title: title,   			
           				promptTitle: title,            		
           				defaultValue: null            			            
           	};
           	
           	if(currentAttribute.type.indexOf("STRING")!=-1){
           		filter.type = TableContentFilterProvider.FIELD_TEXT;
               	holder = "STRING";
           	}        	        	
           	else if(currentAttribute.type == "INTEGER"){           	                              
           		    filter.type = TableContentFilterProvider.FIELD_TEXT_POPUP;
           		    filter.defaultValue = null;
           		    filter.params = {
           				fieldWidth: 240,
           				fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField",
           				fieldArgs: {'showNumericOperators': true}
           			};                         		
           		holder = "INT";
           	}
           	else if(currentAttribute.type == "TIMESTAMP"){
           		filter.type = TableContentFilterProvider.FIELD_DATETIME_RANGE;
           		holder = "DATE";        
           		filter.fromKey = "From";
           		filter.toKey = "To";
           		filter.processFilter = true; // parent class handle processing the to and from date time params                                                
                   filter.prompt = title;                 
           	}
           	filter.name = "customFilter-identifier-holder-///"+holder+"///"+currentAttribute.itemId;
           	currentAttribute.filterId = filter.name;
           	if (currentAttribute.type == "TIMESTAMP") {
                filter.label = title;
                this.addDateTimeRangeFilter(filter, filters, true);
            }
            else {
                filters.push(filter);
            }
        }
        return filters;
    },
    // Base method to prepare the table viewer before querying new results
    // 
    _prepareTableUIForQuery: function() {
        this.showInitLoadProgress = true;
        this.tableViewer.setContent([]);
        this.tableViewer.refresh();
        this.tableViewer.showLoadingProgress();
        this.setInProgress(Constants.getMessage("msgQueryTableList", this._typeLabel));        
    },

    // Base method to do additional processing on the returned results.
    // 
    _processResults: function(resultsDTO){
        // default to no work
    },
        
    // method invoked by the filter "Run" action to query with server side filtering. 
    runQuery: function(filterArgs, updatePageOnly) {

        // if the content has been reset most likely do to changes in  
        // filter explorer selection then treat this as a first time 
        // query and honor runOnOpen options.
        if (this.contentReset){
            this.contentReset = false; // clear reset so "Run" from within table will function
             if (!filterArgs || this._isUnfilteredQuery(filterArgs)){
                // check auto run flag
                if (!this._checkRunOnOpen()) {
                    return;
                }
            }
        }
        // set a flag to indicate that a query had ran
		this._hasRanQuery = true;
		
        if(this.tableViewer){
    		this.tableViewer.noItemMessage =  "";
    	}

        var args = this._prepareQueryArgs(filterArgs, updatePageOnly);
        this._prepareTableUIForQuery();
        
        if(typeof updatePageOnly != "undefined") {
            this.updatePageOnly = updatePageOnly;
        }

        var self = this;
        var isNewQuery = !this.queryToken;
        //save the timestamp when this request is created
        var requestTimestamp = new Date();
        this.lastRequestTimestamp = requestTimestamp;

        if (this.clearSelectionOnQuery && isNewQuery && this.tableViewer && this.hasSelectedRows()) {
            // clear selection only on new query
            this.tableViewer.clearSelection(true /* notify */, false /* refreshDisplay */);
        }

        var callback = {
            success: function(results){
                self.showQueryResults(results, requestTimestamp);
                if (dojo.isFunction(self.onQueryComplete)) {
                    // allow optional processing after a new query is completed and result is shown
                    self.onQueryComplete();
                }
            },
            failure: function(error){
                self.showQueryError(error);
                if (isNewQuery && dojo.isFunction(self.onQueryComplete)) {
                    self.onQueryComplete();
                }
            }
        }
        
        // specify the project area.
        if(this.projectAreaItemId) {
            args.processArea = this.projectAreaItemId;
        }
        if (this.configurationItemId) {
            args[OslcConfigParamName] = this.configurationItemId;
        }
        var responseHandler = new this._searchResponseHandlerType(callback, "success", "failure");          
        this._searchFunction(responseHandler, args);

        // update the external UI after the query is run unless explicitly skipped or view is within a section or in a dialog
        if (!this.isInPicker && !this.isInSection && !this.skipUpdateOnQuerySelectionChanged &&
            this.queryFilterProvider && this.queryFilterProvider.currentSelectedQueryID) {
            this.queryFilterProvider.querySelectionChanged({
                title: this.queryFilterProvider.currentSelectedQueryID,
                filters: this.queryFilterProvider.currentSelectedQuery
            });
        }
        
        // auto-save
        if (this._autoSaveEnabled && this.filterProvider && dojo.isFunction(this.filterProvider.onSaveQuery)) {
            var queryValues = {
            	folder: null,
            	saveColumns: true,
            	scope: FiltersQueriesClient.autoSaveScopeId,
            	title: com.ibm.asq.common.web.ui.internal.util.Utility.getDateTimeString(new Date())
            };
            setTimeout(
            	dojo.hitch(this, function() {
                    this.filterProvider.onSaveQuery(/* parent item */ null,
                                                    /* query item */ null,
                                                    /* query values */ queryValues,
                                                    /* original query */ null,
                                                    /* success callback */ function() {},
                                                    /* error callback */ console.error);
                }), 100
            );
        }
    }, 
    
    onQueryComplete: function(){
    	//Disable the top PDF button for empty tables or tables with hidden items (via restricted query).
    	var tableViewer = this.tableViewer;
    	if (tableViewer) {
		    var visibleItems = tableViewer.getCurrentDisplayItemsCount();
			if (this._pdfButton != null) {
				 this._pdfButton.setDisabled(visibleItems == 0);
	    	}
    	}
    },
    
    // the filtered table should be cleared for later re-use
    resetFilteredContent: function(){
        if(!this._runOnOpen){
            // reset no items message
            this.tableViewer.noItemMessage = NoItemMessage;
        }
        this.tableViewer.reset();
        this.filterArgs = {};
        // set flag indicating the the table has be reset (i.e. we are starting over)
        this.contentReset = true;
    },
    
    _isUnfilteredQuery: function (queryArgs){
        if (!queryArgs.categories || queryArgs.categories === ""){
            if (!queryArgs.ownerUUIDs){
                return true;
            }
        }
        return false;
    },
    
    // return the view header node for external UI update on the title
    getViewHeaderNode: function() {
        return this.viewHeaderNode;
    },
	
	// run the query automatically if the preference dictates
    initRunQuery: function() {  
        var initOpenFilter = this.isInitiallyOpen();

        // when this method is called, we have completed initialization
        // call the initializeCompleted notification if one is defined.
        if(this.onInitializeCompleted) {
            this.onInitializeCompleted();
        }
        // the list can be override the runOnOpen preference. If it's set
        // obey the override setting.
        if (this._checkRunOnOpen() || (this.filterQueryID && this.filterQueryID.sqItemId)) {
            this._initFilterOpenState = initOpenFilter;
			this._initRunQuery();
		}else {
			this.stopInProgress();
			if (this.tableViewer) {
		    	if(!this._runOnOpen){
		    		this.tableViewer.noItemMessage = NoItemMessage;
		    	}
				// We are not running the initial query. Yield now to avoid
				// possible calling refresh more then once in the same exec path.
				setTimeout(dojo.hitch(this, function(){
					this.tableViewer.refresh();
					
					// the table is initialized completely. Apply the
					// filter's open state.
					if (this.isInitiallyOpen()) {
						this.tableViewer.toggleFiltersDisplay(true);
					}
				}), 100);
            }
		}       
    },  
    
    // return true if condition are set to run the query on opening
    _checkRunOnOpen: function(){
        // the list can be override the runOnOpen preference. If it's set
        // obey the override setting. Also if the page is specifically
        // set not to be a query page then run is true.
        return (this._runOnOpen || this.overrideRunOnOpenPref || (this.isQueryPage != undefined && !this.isQueryPage && this.doRunInitQuery));
    },  
    
    _initFilterArgs: function() {
        var filterArgs = this.initFilterArgs ? this.initFilterArgs : this.getCachedFilters();
        if (filterArgs == null) {
        	filterArgs = dojo.clone(this._defaultFilterArgs);
        }
        return filterArgs;       
    },
    
    _initRunQuery: function() {	
        var filterArgs = this._initFilterArgs();
        if (this._autoSaveEnabled && this._isEqual(filterArgs, this._defaultFilterArgs)) {
        	this.runAutoSavedQuery();
        }
        else {
        	this.runQuery(filterArgs, false);
        }
    },	
	
    // compares two associative arrays for equality
    _isEqual: function(assocArray1, assocArray2) {
    
    	if (assocArray1 == assocArray2) {
    		return true;
    	}
    	
    	for (var key in assocArray1) {
    		if (assocArray1[key] != assocArray2[key]) return false;
    	}
    	
    	for (var key in assocArray2) {
    		if (assocArray1[key] != assocArray2[key]) return false;
    	}
    	
    	return true;
    },
    
    _transformrelativeToLongDate: function(currentDate,relObj){
    	var currentDate = currentDate;
    	var from = -( relObj.fromDateTime);
    	var relative = "";
    	switch(relObj.relative)
	    {
	    	case "minutes":
	    		relative = "minute";
	            break;
	        case "hours":
	        	relative = "hour";
	            break;
	        case "days":
	        	relative = "day";
	            break;
	        case "weeks":
	        	relative = "week";
	            break;
	        case "months":
	        	relative = "month";
	            break;
	        case "years":
	        	relative = "year";
	            break;
	    };
	    currentDate = dojo.date.add(currentDate,relative,from);
		return currentDate.getTime();
    },
    
	toggleQueryRunning: function(isRunning) {
		
	},
	
	// refresh by simply running the query with the current settings
	refreshQuery: function() {
        // preference is set to not auto run query and filter has never been ran to set the filterArgs
        if (this.filterArgs == undefined) {
            this._initRunQuery();
        } else if (this.filterArgs && !this._isRunningQuery) {
			this.runQuery(null, false);
		}
	},
	
	runAutoSavedQuery: function() {
		var self = this;
        var callback = dojo.hitch(this, function(queryObj) {
        
    		// disable autosave while running the autosave query
    		var isAutoSaveEnabled = self._autoSaveEnabled;
    		self._autoSaveEnabled = false;
        		
        	if (queryObj && queryObj.filters && this.savedQueriesModelProvider && dojo.isFunction(this.savedQueriesModelProvider.setAndRunQuery)) {
	        	self.savedQueriesModelProvider.setAndRunQuery(queryObj);
	        	self.tableViewer.toggleFiltersDisplay(true);
	        }
	        else {
	            self.runQuery(self._defaultFilterArgs);
	        }
       		self._autoSaveEnabled = isAutoSaveEnabled;
	    });
		
		FiltersQueriesClient.getAutoSavedQueries(callback, this.queryFilterProvider.artifactTypeQueryKey, this.projectAreaItemId);
	},
	//requestTimestamp holds a Date of when the request was created.
	//  can be compared against this.lastRequestTimestamp for result handling purposes like
	//  is this the latest request?
	showQueryResults: function(resultsDTO, /*optional*/ requestTimestamp ) {
        this.stopInProgress();
        
        // HACK: to workaround a irregular return result from TER search...
        if(dojo.isArray(resultsDTO)) {
            resultsDTO = resultsDTO[0];
        }
		if (resultsDTO != null && 
            (resultsDTO.status == Constants.ARTIFACT_SEARCH_STATUS_OK || 
             resultsDTO.status == Constants.ARTIFACT_SEARCH_STATUS_OK_EXPIRED)) {
            
            // perform any additional processing on the result.
            this._processResults(resultsDTO);
            
            //search ok. show results
			if (this._searchFilterCallback && dojo.isFunction(this._searchFilterCallback)) {
				resultsDTO.results = this._searchFilterCallback(resultsDTO.results);
			}
			this._doSearchCallback(resultsDTO.results, resultsDTO.groupCounts, resultsDTO.currentPage);
            
            if(this.initialSelectedRows) {
                this.tableViewer.selectRows(this.initialSelectedRows, true);
                if (this.tableViewer.getTableRowsCheckable()) {
                    // refresh to update the checkbox rendering
                    this.tableViewer.refresh();
                }
                delete this.initialSelectedRows;
            }
            // if the query has been expired. Show a message to warn the user, but only if there
            // is no suppress flag.
            var ignore = this.tableViewModeId != "general" || this.ignoreStaleQuery;
            if(resultsDTO.status == Constants.ARTIFACT_SEARCH_STATUS_OK_EXPIRED && !ignore) {
                var args = {
                    message: Constants.getMessage("msgQueryExpired"),
                    primaryTitle: ""
                };
                var alert = new com.ibm.asq.common.web.ui.internal.widgets.AlertDialog(args);
                alert.open();
            }		  	
		} else if (resultsDTO != null && resultsDTO.status == Constants.ARTIFACT_SEARCH_STATUS_MAX_EXCEEDED) {
            //too many results, show warning dialog
            this.showQueryThresholdWarning(resultsDTO);			
		} else {
            //some error occurred
			this.showQueryError({
                message: resultsDTO ? resultsDTO.message : "Unknown Error"  
            });			
		}
        // remove the suppress flag.
        delete this.ignoreStaleQuery;
        
        // apply the initial filter open.
        if(this._initFilterOpenState) {
            this._initFilterOpenState = false;
            this.tableViewer.toggleFiltersDisplay(true);
        }
	},
	
    _doSearchCallback: function(searchResults, groupCounts, currentPage) {
		if(!this.tableViewer || this.tableViewer.uninitialized){
			console.error(this.declaredClass + ": tableviewer not found");
			return;
		}
		if (dojo.isFunction(this._searchCallback)) {
			if(searchResults){
				if(groupCounts){
					searchResults.groupCounts = groupCounts;
				}
				if(currentPage){
					searchResults.currentPage = currentPage;
				}
			}
            this._searchCallback(searchResults);
        } else {
            console.error(this.declaredClass + ": no search callback secified!");
        }
    },

    showQueryError: function(error) {
		if(!this.tableViewer || this.tableViewer.uninitialized){
			console.error(this.declaredClass + ": tableviewer not found");
			return;
		}
		this.stopInProgress();
		var messageClass = (error && error.errorClass) ? error.errorClass : null;
        var message = (error && error.message) ? error.message : null;
        var details = error;
        
        // We are now more aggressive in checking user's license (floating). We now
        // check lincense when querying artifacts. If the error is due to lack of 
        // license, dont' show any stack trace, etc.
        //
        if(messageClass && messageClass == "com.ibm.team.repository.common.LicenseNotGrantedException") {
            details = null;
        }
        
		this.tableViewer.showContentError(message);	
        
        if (this.isQueryPage && this.viewHeaderNode) {
            this.viewHeaderNode.setStatus(message, ViewHeaderLayout.ERROR, null, details);
        }        
	},
	
	showQueryThresholdWarning: function(resultsDTO) {
        var dialogArgs = {
            primaryTitle: Constants.getMessage("labelSearchLimitWarning", resultsDTO.totalSize),
            yesLabel: Constants.getMessage("labelRefine"),
			yesCallback: dojo.hitch(this, function() {
                //set proper policy; user can refine search
				this.filterArgs.policy = Constants.ARTIFACT_SEARCH_POLICY_ENFORCE;
            }),
			noLabel: Constants.getMessage("labelLoadFirst", resultsDTO.size),
            noCallback: dojo.hitch(this, function() {
				//truncate the search to the threshold
                this.filterArgs.policy = Constants.ARTIFACT_SEARCH_POLICY_TRUNCATE;
				this.runQuery(this.filterArgs);
            }),
			cancelLabel: Constants.getMessage("labelLoadAll"),
            cancelCallback: dojo.hitch(this, function() {
                //run the query anyway, getting all results
                this._dialog.close();
				this.filterArgs.policy = Constants.ARTIFACT_SEARCH_POLICY_IGNORE;
                this.runQuery(this.filterArgs);
            }),		
			showCancel: true,	
            isClosable: false
        };                
        this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(dialogArgs);
        this._dialog.setWidth("600px");
		this._dialog._cancelButton.onclick = dialogArgs.cancelCallback;
		
        var messageNode = document.createElement("span");
        messageNode.innerHTML = Constants.getMessage("msgSearchLimitWarning", resultsDTO.totalSize);
		  	
		this._dialog.contentContainer.appendChild(messageNode);
        this._dialog.open();		
	},
	
	addArtifactStateFilter: function(filters) {
		if (!this.explorableArtifactType) {
			return;
		}
		var stateFilter = {
			name: "stateIds", // must match key in the arg list of the API
			dbName: "state",
			title: Constants.getMessage("labelStateLabel"),
			promptTitle: Constants.getMessage("labelState"),
			type: TableContentFilterProvider.FIELD_TOGGLELIST,
			defaultValue: [],
			params: {}
		};
		filters.push(stateFilter);

        var wfm = this.workflowManager || WorkflowManager;
		wfm.loadWorkflows().then(dojo.hitch(this, function() {
			var workflowModel = wfm.getWorkflowModelForModelType(this.explorableArtifactType);
	    	stateFilter.params = {
    			options: dojo.map(workflowModel.getStates(), function(state) {
					return {
						name: state.name,
						value: state.id,
						checked: false
					};
				})	
	    	};
		}));
	},
	
	addArtifactPriorityFilter: function(filterObj, filtersCollection, artifactPriorities) {
        
        var priorityOptions = [];
        var length = artifactPriorities ? artifactPriorities.length : 0;
        for (var i = 0; i < length; i++) {
            priorityOptions.push({
                name: artifactPriorities[i].name,
                value: artifactPriorities[i].id,
                checked: false
            });
        }

        var priorityFilter = {
            name: filterObj.name, // must match key in the arg list of the API
            title: filterObj.label,
            promptTitle: filterObj.prompt,
            type: filterObj.type,
            defaultValue: [],
            params: {
                options: priorityOptions
            }
        };
        filtersCollection.push(priorityFilter);
        
    },
    	
    addRiskFilter: function(filterObj, filtersCollection) {
        var riskFilter = RiskUtil.createRiskFilter(filterObj); 
        riskFilter.showInSelectorTrim = false; 
        filtersCollection.push(riskFilter);  
    },
    
    addApprovalFilter: function(filtersCollection){
    	var approvalFilter = {
    			name: "approval",  // must match key in the arg list of the API
    			title: Constants.getMessage("labelPendingReviewApprovalsfilterTitle"),
    			promptTitle: Constants.getMessage("labelPendingReviewApprovalsfilterTitle"),
    			type: TableContentFilterProvider.FIELD_ENUM,
    			defaultValue: "",
                showInSelectorTrim: false,
    			params: [{
    				name:  Constants.getMessage("labelAnyCap"),
    				value: ""
    			}, {
    				name:  Constants.getMessage("labelPendingReviewApprovalsfilterText"),
    				value: "mypendings"
    			}]
    	};
    	filtersCollection.push(approvalFilter); 	    		
    },
    
    addLockFilter: function(filtersCollection){
    	var lockFilter = {
			name: "locked",
			title: Constants.getMessage("labelLocked"),
			promptTitle: Constants.getMessage("labelLocked"),
			type: TableContentFilterProvider.FIELD_ENUM,
			defaultValue: "",
            showInSelectorTrim: false,
			params: [{
				name:  Constants.getMessage("labelAnyCap"),
				value: ""
			}, {
				name:  Constants.getMessage("labelLocked"),
				value: "locked"
			}, {
				name:  Constants.getMessage("labelUnlocked"),
				value: "unlocked"
			}]
    	};
    	filtersCollection.push(lockFilter);		
    },
    
    addDateTimeRangeFilter: function(filterObj, filtersCollection,ignoreDateSignature) {
    	if(!ignoreDateSignature){
    		this._processDateTimeFilter = filterObj.processFilter; // subclass has option to have the params processed
                                                               // here instead of handling it in the subclass
    		this._dateTimeFilterKey = filterObj.name;        // these keywords must be specified in order to
    		this._dateTimeFromFilterKey = filterObj.fromKey; // have the params processed here
    		this._dateTimeToFilterKey = filterObj.toKey;
    	}
        var datetimeRangeFilter = {
            name: filterObj.name,  // there are two attributes in the filter for from and to datetime, the
                                   // consumer needs to match the name to compose proper parameters to run query
            title: filterObj.label,
            dbName: filterObj.dbName?filterObj.dbName:null,
            promptTitle: filterObj.prompt,
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue: filterObj.defaultValue,  // if defined, it should be in the format of
                                                   // {
                                                   //     fromDateTime: <date in long>,
                                                   //     toDateTime: <date in long>,
                                                   //     relative: "true" or "false" for display relative date or specific dates
                                                   // },
            params: {
                fieldWidth: 350,
                fieldClass: "com.ibm.asq.common.web.ui.internal.widgets.layout.FormDateTimeRangeField"
            }
        };
        filtersCollection.push(datetimeRangeFilter);
    },
    
    // Creates a project timeline's iterations filter for the artifact query.
    addTimelineIterationFilter: function(filtersCollection, dbName) {
        var iterationFilter = TimelineIterationsFilterUtil.getTimelineInterationsFilter(dbName, this.projectAreaItemId);
        filtersCollection.push(iterationFilter);
    },
    
    
    // Creates a project timeline's iterations filter for the artifact query.
    addTeamAreaFilter: function(filtersCollection, dbName) {
        var teamAreaFilter = TeamAreaFilterUtil.getTeamAreaFilter(dbName, this.projectAreaItemId);
        filtersCollection.push(teamAreaFilter);
    },
    
 // Creates a project timeline's iterations filter for the artifact query.
    addChannelFilter: function(filtersCollection, dbName) {
        var channelFilter = ChannelFilterUtil.getChannelFilter(dbName, this.projectAreaItemId);
        filtersCollection.push(channelFilter);
    },
    
    // @obsolete - replaced by TableContentFilterProvider.FIELD_CONTRIBUTOR_TOGGLELIST
	addContributorFilter: function(filterObj, filtersCollection, callback) {
        if (dojo.isArray(this.contributors) && this.contributors.length > 0) {
			this._doAddContributorFilter(this.contributors, filterObj, filtersCollection, callback);
			return;
		}
		//creates a filter with the list of contributors
        var self = this;
        var serviceObj = {
            success: function(contributors) {
				self._doAddContributorFilter(contributors, filterObj, filtersCollection, callback);
            },
            failure: function(e) {
                self._error(e);
				callback();
            }
        };
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        UserClient.getContributors(responseHandler);
    },
	
    _doAddContributorFilter: function(contributors, filterObj, filtersCollection, callback) {
        contributors = contributors || [];
		this.contributors = contributors;
		for (var i = 0; i < this.contributors.length; i++) {
            if (com.ibm.asq.common.web.ui.internal.util.Utility.isUnassignedUserId(contributors[i].itemId)){
				contributors[i].name = Constants.getMessage("labelUnassigned");
			}
            contributors[i].value = contributors[i].itemId;
            contributors[i].checked = false;
        }
        
        var contributorFilter = {
            name: filterObj.name,  // must match key in the arg list of the API
            title: filterObj.label,
            promptTitle: filterObj.prompt,
            type: filterObj.type,
            defaultValue: [],
            params: {options: contributors}
        };
        filtersCollection.push(contributorFilter);
        callback();		
	},
    
    addScriptTypeFilter: function(filterObj, filtersCollection, callback) {
        if (dojo.isArray(this.exeScriptTypes) && this.exeScriptTypes.length > 0) {
            this._doAddScriptTypeFilter(this.exeScriptTypes, filterObj, filtersCollection, callback);
            return;
        }
        
        //creates a filter with the list of script types
        var self = this;
        var serviceObj = {
            success: function(types) {
                self._doAddScriptTypeFilter(types, filterObj, filtersCollection, callback);
            },
            failure: function(e) {
                self._error(e);
                callback();
            }
        };
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        RegistryClient.getAllExecutionScriptTypes(responseHandler);
    },
    
    _doAddScriptTypeFilter: function(types, filterObj, filtersCollection, callback) {
        types = types || [];
        this.exeScriptTypes = types;

        // filter out scriptless type
        var length = types.length;
        var scriptTypes = [];
        for (var i = 0; i < length; i++) {
            var type = types[i];
            var name = type.name;
            if (name == "Unknown" || name == "NoScript") { continue; }
            type.displayName = (name == DEFAULT_SCRIPT_TYPE) ? Constants.getMessage("labelManual") : 
                                                               Constants.getExtensionDisplayMessage(name);
            scriptTypes.push({
                name: type.displayName,
                value: type.id,
                checked: false
            });
        }
        
        // sort the entries
        length = scriptTypes.length;
        for (var ix = 0; ix < length; ix++ ) {
            for (var iy = ix + 1; iy < length; iy++ ) {
                if (scriptTypes[iy].name < scriptTypes[ix].name) {
                    var swap = scriptTypes[ix];
                    scriptTypes[ix] = scriptTypes[iy];
                    scriptTypes[iy] = swap;
                }
            }
        }

        var scriptTypesFilter = {
            name: filterObj.name,  // must match key in the arg list of the API
            title: filterObj.label ? filterObj.label : Constants.getMessage("labelScriptType") + Constants.getMessage("labelColen"),
            promptTitle: filterObj.prompt ? filterObj.prompt : Constants.getMessage("labelScriptType"),
            type: TableContentFilterProvider.FIELD_TOGGLELIST,
            defaultValue: null,
            params: {options: scriptTypes}
        };
        
        filtersCollection.push(scriptTypesFilter);
        callback();     
    },
    
    // Summary
    // this method will create the filterParams for CopiedFrom or CopiedRoot filters
    // filterName idetified the type of filter "copiedRoot" or "copiedFrom"
    createCopiedFilterObject: function(filterName) {
    	
    	var label = Constants.getMessage("labelCopyRootTableViewer");
    	if(filterName == "copiedFrom"){
    		label = Constants.getMessage("labelCopiedFromTableViewer");
    	}
        return {
            name: filterName,
            title: label,
            promptTitle: label,
            type: TableContentFilterProvider.FIELD_TEXT_POPUP,
            defaultValue:  null,
            params: {
                usePopup: true,
                updateDisplayOnValueChanged: true,
                fieldClass: "com.ibm.rqm.planning.web.ui.internal.view.common.ArtifactSelectorPanelFormField",
                fieldWidth: 240,
                fieldArgs: {
                    panelWidth: 240,
                    useUnassigned: true,
                    unassignedLabel: Constants.getMessage("labelUnassignedCopiedFilter"),
                    selectorPageSize: 20,
                    artifactType: this.explorableArtifactType,
                    projectAreaContext: this.projectAreaContext
                }
            }
        };
    },
    
    //Summary
    //this method normalize Artifact filters objects into an 
    //arrays that contains itemIds for the actual query.
    _normalizeFilterToItemIdsArray: function(filterArgs, indexName) {
        var dataObjects = filterArgs[indexName];
        if(dataObjects) {
            if (dojo.isArray(dataObjects)) {
                var len = dataObjects.length;
                var itemIds = [];
                for (var i = 0; i < len; i++) {
                	var item = dataObjects[i];
                    var vItemId = (item.versionableItemId) ? item.versionableItemId : item;
                    itemIds.push(vItemId);
                }
                filterArgs[indexName] = itemIds;
            } else {
                delete filterArgs[indexName];
            }
        }
        return filterArgs;
    },    
    
    // convenient pass through method to add pending items to the table.
    // pending add items are shown differently and are always shown on
    // top of the table and are not a part of the main table content. They
    // will always shown in any pages. The base table provides action to 
    // remove these pending adds.
    addItemsPending: function(items) {
        this.tableViewer.addItemsPending(items);
    },
    
    // convenient pass through method to remove pending items from the table.
    // pending remove items are shown differently and are shown in-place in the
    // table. The base table provides action to restore these pending deletes.
    // 
    deleteItemsPending: function(items){
        this.tableViewer.deleteItemsPending(items);
    },
    
    // convenient pass through method to get all pending add items from the table.
    getPendingAddItems: function(items) {
        return this.tableViewer.getPendingAddItems(items);
    },
    
    // convenient pass through method to get all pending delete items from the table.
    getPendingDeleteItems: function(items){
        return this.tableViewer.getPendingDeleteItems(items);
    },
    
    // Summary:
    //    Returns whether the current table has selected rows.
    hasSelectedRows: function()
    {
        var selectedItems = this.tableViewer.getCheckedRows();
        return selectedItems.length > 0;
    },
    
    // Summary:
    //    Main entry point for all selection based table actions. This method assembles all of the
    //    selected item's ids and invokes the actually function that carries out the
    //    action. This structure is necessary to uniformly handle the 'select all' 
    //    case in vitrual content (paging) tables. In that situation, the table does
    //    not have all the data (ids) yet and would require to fetch them before
    //    invoking the action.
    //      idType - the type of ids to obtained for the action (id, itemId, versionableItemId)
    //      context - the object of the funcName.
    //      funcName - the action function name to be invoked with the assembled ids. The funcName must be in the context specified.
    //      param1, param2 - additional params to be passed to the function identified by funcName.
    //
    invokeAction: function(idType, context, funcName, param1, param2){
        var selectedItems = this.tableViewer.getCheckedRows();
        var itemIds = [];
        var length = selectedItems.length;
        
        for (var i = 0; i < length; i++) {
            itemIds.push(selectedItems[i][idType]);
        }
        var actionFunc = dojo.hitch(context, funcName);
        actionFunc(itemIds, param1, param2);
    },
    
    // Summary:
    //    Main entry point for all table header actions. This method prepares the
    //    the list's selected item ids and calls the abstract method 'doBatchUpdate'
    //    Specific subclasses would perform artifact specific batch update, usually
    //    by creating a Model action to carry out the change.
    //
    headerActionInvoked: function(columnIndex, actionId)
    {
        var idType = 'versionableItemId'; //default to versionableItemId
        this.invokeAction(idType, this, "doBatchUpdate", columnIndex, actionId)
    },

    // Summary:
    //    Abstract method to actually performs the batch change operations. Specific
    //    subclassess need to override this method to do the work on the artifact type.
    doBatchUpdate: function(uids, columnIndex, actionId) 
    {
    },    
    
    _error: function(e) {
        if (this.isQueryPage) {
            this.viewHeaderNode.setStatus("Error: " + (e.message || "Unknown error"), ViewHeaderLayout.ERROR, null, e);
        }
        console.error(this.declaredClass + ": Error: " +(e.message || "Unknown error"));
    },
    
    // This path is used by artifacts which have been implemented in the new print engine.  Not all 
    // artifact tables have been switched to the new path so we need to maintain both this method 
    // and _onPrintpdfActionClick below for now.
    _onPrintActionClick: function(printType) {
        // summary print
        if( !this.hasSelectedRows() ) {
            var content = this.tableViewer.getContent();
            var len = content ? content.length : 0;
            
            if(len > 0) {
                var ids = [];
                for (var i = 0; i < len; i++)
                    ids.push(content[i].id);
                
                this._doPrintAction(ids, printType, null);
            }
        }
        else {
            // printing detail contents. Also need to handle select all case.
            this.invokeAction('id', this, "_doPrintAction", printType, null);
        }
    },

    // Summary:
    //    Base implementation for PDF print in the table. Subclass must define a 'pdfPrintType'
    //    attribute to use this method, or define its own to handle.
    // **deprecated** use _onPrintActionClick above
    _onPrintPdfActionClick: function(/*optional*/ isHistory) {
        var isSummary = false;
        
        // no rows selected. It's a summary of all contents. Need to get all of
        // ids to print the summary of each row.
        if (!this.hasSelectedRows()) {
            isSummary = true;
            var content = this.tableViewer.getContent();
            var len = content ? content.length : 0;
            
            if(len > 0) {
                var ids = [];
                for(var i = 0; i < len; i++) {
                    ids.push(content[i].id);
                }
                this._doPrintPdfAction(ids, isSummary, isHistory);
            }
        }
        else {
            // printing detail contents. Also need to handle select all case.
            this.invokeAction('id', this, "_doPrintPdfAction", isSummary, isHistory);
        }
    },
    
    // This path is used by artifacts which have been implemented in the new print engine.  Not all 
    // artifact tables have been switched to the new path so we need to maintain both this method 
    // and _doPrintAction below for now.
    _doPrintAction: function(ids, printType, /*this is not used*/dummyParam) {
        if( !this.pdfPrintType )
            console.error("Must supply a PDF print type, or override the _onPrintPdfActionClick method!");
        
        this.tableViewer.sendPrintRequestByIds(ids, this.pdfPrintType, printType, "application/pdf", this._projectAlias);
    },
    
    // **deprecated** use _doPrintAction above
    _doPrintPdfAction: function(ids, summary, /*optional */isHistory) {
        if(!this.pdfPrintType) {
            console.error("Must supply a PDF print type, or override the _onPrintPdfActionClick method!");
        }
        var type = this.pdfPrintType;
        var loc = window.location.href;
        loc = loc.replace(/[&]/g,"%26");
        this.tableViewer.sendPdfPrintRequestByIds(ids, /* itemId not required */ null, type, loc, this._projectAlias, summary, null, isHistory);   
    },
    
    _showAlertDialog: function(message){
        var alertDialog = new AlertDialog({
            'message': message
        });
        alertDialog.setSecondaryTitle("");
        alertDialog.open();
    },
    
    _showArtifactChangedMessage: function(viewHeader, artifactType, changeType){
        var typeMsg = null;
                
        if (changeType == GlobalEvents.ArtifactsAdded) {
            typeMsg = Constants.getMessage("labelArtifactsAdded");
        }
        else if (changeType == GlobalEvents.ArtifactsUpdated) {
            typeMsg = Constants.getMessage("labelArtifactsModified");
        } 
        else if (changeType == GlobalEvents.ArtifactsDeleted) {
            typeMsg = Constants.getMessage("labelArtifactsDeleted");
        }
        if (typeMsg) {
            var msg = Constants.getArtifactTypeMessage("msgRefreshModArtifact", artifactType, typeMsg);
            viewHeader.setStatus(msg);
        }
    },
    
    _reContructTable: function() {
        var currentPageCtr = this.tableViewer.getCurrentPageControl();  
        this.provider = this._constructTableContentProvider();
        this.tableViewer.setContentProvider(this.provider);
        this.tableViewer.reconstruct(currentPageCtr);
        
        if (this.tableViewer)
        {
            var listener = this.tableViewer.getTableListener();
            if(listener)
                listener.rowCheckStateChanged(this.tableViewer);
        }
    },

    // Recreate the category filters for the table due to the changes to artifact's categories. 
    // Throw away the category value loader to clear old cached values and recreate the filters
    // from the new category types.
    // 
    _resetCategoryFilters: function() {
        if (this.filterProvider) {
            // clear the value loader, create a new one to fetch the values.
            this.catValuesLoader = null;
            var newCategoryFilters = CategoryUtil.getCategoryTypesFilters(this._getCategoryValuesLoader(), 'loadCategoryValues', this.categoryTypes);
            var newFilters = [];
            var oldFilters = this.filterProvider.filters;
            
            // keep all of the non-categories filters and add back the new
            // category filters.
            for(var i = 0; i < oldFilters.length; i++) {
                if(oldFilters[i].name.indexOf("categories") == -1)
                    newFilters.push(oldFilters[i]);
            }
            this.currentCategoryFilters = newCategoryFilters;
            newFilters = newFilters.concat(this.currentCategoryFilters);
            delete this.filterProvider.filters;
            this.filterProvider.filters = newFilters;
            
            this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        }
    },
    
    clearSubcategoryFilterSelection: function(filters) {
    	this._getCategoryValuesLoader().clearCascadeFiltering(filters);
    },

    // Receive notification when our host page is activated (in view). If we have
    // outstanding event to update the categories, process it. Otherwise, refresh
    // the table.
    // 
    onActivated: function() {
		// If this is a first call to this page when it's open, we don't have to
		// care about this activate. Otherwise, we could force an unnecessary
		// refresh on the table while it's being initialized.
		//
		if(!this.hasActivated) {
			this.hasActivated = true;
			return;
		}
        if(this.refreshCategoryWhenActivated) {
            this.refreshCategoryWhenActivated = false;
            setTimeout(dojo.hitch(this, "_handleCategoriesChanged", this.explorableArtifactType));
        }
        else if(this.tableViewer){
            this.tableViewer.refresh();
        }
    },

    // Create a category values loader. If one has been created, reuse that one. The
    // loader caches fetched category values to avoid excessive fetching from the server.
    //
    _getCategoryValuesLoader: function() {
        if(!this.catValuesLoader) {
            this.catValuesLoader = new com.ibm.rqm.planning.web.ui.internal.view.table.CategoryValuesLoader({
                projectAreaItemId: this.projectAreaItemId,
                artifactType: this.explorableArtifactType,
                // Create a reference to this table's headerRenderer in order to get access to the filter's selected values from the category filter loader.
                headerRenderer: this.tableViewer.headerRenderer
            });
        }
        return this.catValuesLoader;
    },
    
    // Handles categories changed. Concrete artifact tables call this method to handle 
    // category change events. If the page isn't in view, it saves the event to process
    // when the page is in view again.
    //
    _handleCategoriesChanged: function() {
        var currUri = this.page ? this.page.uri : "";
        var uriParams = dojo.queryToObject(currUri);
        var hashParams = dojo.queryToObject(window.location.hash);

        // if we are not in view and received category changed event,
        // save the event and dispatch it when we are in focus again.
        if (!dojo.isDescendant(this.domNode, document) || uriParams.subAction != hashParams.subAction){
            this.refreshCategoryWhenActivated = true;
            return;
        }
        var handler = {
            self: this,
            'success': function(categoryTypes){
                var self = this.self;
                
                // Reset the table needs to occur previous to resetting category filters in order to count with a refreshed
                // Category Model after the table sets the category columns.
                self._reContructTable();
                
                //reset category filters
                self.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
                self._resetCategoryFilters();
            },
            'failure' : function () {
            }
        }
        var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
        CategoryClient.getCategoryTypes(responseHandler, this.explorableArtifactType, /*no archived*/false, /*no category values*/false);
    },
    
    // Configures the table to have switchable view modes.
    _configureViewModes: function(viewModes, tableViewer) {
        var callback = dojo.hitch(this, '_handleViewModeChanged');
        
        for (var i = 0; i < viewModes.length; i++) {
            var viewMode = viewModes[i];
            tableViewer.addViewMode(viewMode.id, viewMode.label, callback, viewMode, viewMode.columnsProfile);
        }
    },
    
   setFocusInSelectedRow: function(){
	   var newSelectedItems = this.getSelectedItems();
		if(newSelectedItems && newSelectedItems.length > 0){
			setTimeout(dojo.hitch(this, function(){
				this.tableViewer.setFocusInRow(newSelectedItems[0]);
			}), 10);
		} 
   } ,
   // Handle view mode changed
    _handleViewModeChanged: function(viewMode){
        this.tableViewModeId = viewMode.id;
        this.ignoreStaleQuery = true;
		
		// if the preference is set to not run on open, we need to obey that
		// when the view mode has changed. Don't auto run the query if the user
		// had not ran a query.
		//
		var runNow = true;
		if(!this._checkRunOnOpen()) {
			runNow = this._hasRanQuery;
		}
		if (runNow) {
			setTimeout(dojo.hitch(this, 'runQuery', null, true));
		}
		else {
			// we have not ran a query. The table would be in update mode at
			// this point. Reset the content.
			this.tableViewer.endLoadingProgress();
            this.tableViewer.noItemMessage = NoItemMessage;
			this.tableViewer.refresh();
		}
    }   
});

/*
 * Common abstract class for paging content table views. Artifacts that supports
 * paging content should subclass from this base class.
 */
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredPagingTableView", 
             com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView,
{
    contentIsVirtual: true,
    currentPage: 0,
    
    // refresh by simply running the query with the current settings
    refreshQuery: function(){
        // This is a new query, reset the query token
        this.queryToken = null;
        this.resultLimit = -1;	
        this.inherited(arguments);
    },
    
    // @override AbstractFilteredTableView to process paging returned values.   
    _processResults: function(resultsDTO){
        var provider = this.provider;
        
        this.queryToken = resultsDTO.queryToken;        
        provider.currentPageIndex = this.currentPage = resultsDTO.currentPage;
        provider.totalPageCount = this.totalPages = resultsDTO.totalPages;
        provider.totalContentCount = this.totalSize = resultsDTO.totalSize;
        
        // the result set size tells us whether the query result actually have all
        // of entries. If resultSetSize is smaller then the totalSize (the actual result
        // count), then the server doesn't have all of the entries. When
        // we do select all, pdf, csv export operations that rely on the entire
        // result set, we will need to re-run the query with the full result set
        // populated on the server.
        // 
        this.resultSetSize = resultsDTO.resultSetSize;
        this.resultLimit = resultsDTO.resultSetSize;
    },

    // @override AbstractFilteredTableView to insert paging arguments.
    _prepareQueryArgs: function(filterArgs, updatePageOnly) {
        if(filterArgs) {
            // non-paging related query, has provided new
            // filters. Make this a new query. Our filter provider
            // could have cleared the token for us. But in case
            // it didn't, always clear the token here.
            this.queryToken = null;
        }
        var args = this.inherited("_prepareQueryArgs", arguments);

        args = dojo.clone(args);
        
        if (updatePageOnly && this.queryToken) {
            // we're still using the same query. 
            this.updatePageOnly = true;
            args["queryToken"] = this.queryToken;
            args["page"] = this.currentPage;
        }
        else {
        	this.resultLimit = -1;  // reset resultLimit for a new query.
            if (this._keepCurrentPage) {
                args["page"] = this.currentPage ? this.currentPage : 0;
                this._keepCurrentPage = false;
            }
            else {
                args["page"] = 0;
            }
        }
        var sortArgs = this.provider.buildGroupSortServerArgs();
        if (sortArgs.length > 0) {
            	//we need to pass the grouping column to have the server sends back the grouping count information
                args['sortColumns'] = sortArgs;
                if(this.tableViewer && this.tableViewer.groupByColumn != -1) {
                		args['groupBy'] = sortArgs[0];
                }
        }
        
        // apply text filter if one is specified.
        var textFilter = this.provider.getTextFilter();
        if (textFilter && textFilter.length > 0) {
            args["textSearch"] = textFilter;
        }
        args["pageSize"] = this.provider.pageSize;
        if(this.tableViewer && this.tableViewer.trim == TableConstants.TRIM_DASHBOARD && this.tableViewer.pageSize){
        	 args["pageSize"] = this.tableViewer.pageSize;
        }
        // include the totalSize as well, an optimization for the server
        // to calculate whether the page would go pass the result set limit.
	    args["resultLimit"] = this.resultLimit;
        if (this.totalSize > 0) {
            args["totalSize"] = this.totalSize;
            if (this.resultLimit == this.totalSize) {
		        args["resultLimit"] = 0;  // unlimited size
            } 
        }
        
        // guard against getting 'all items' when we are
        // resetting the query. The user could have switched to
        // show all for a small query and reset the query. 
        // A new query would be indicated by the queryToken
        // being null.
        if(args.pageSize == -1 && this.queryToken == null) {
        	// WI 32649: User does not want to lose the Select All setting when 
        	// filtering, sorting or refreshing the viewer. In order to prevent
        	// performance issues, instead of Show All it will return the MAX page
        	// size.
            // we explicitly supports show all and this is an user
            // selected show all. Don't reset the page size.
            if(!this.forceShowAll) {
                // The page size of -1 could be a temporary value due to the current content size.
                // If the content size is less then page size, the page size could be set to show all.
                // Use the last selected page size for the query, but we need to cap it at the max
                // page size allowed to avoid performance issues.
                var pageSize = (this.tableViewer.lastSelectedPageSize == -1) ? TableConstants.MAX_PAGE_SIZE : this.tableViewer.lastSelectedPageSize;
                this.tableViewer.setContentPageSize(pageSize);
                this.provider.pageSize = pageSize;
                args.pageSize = pageSize;
            }
        }
        // added paging args.
        return args;
    },
    
    // @override AbstractFilteredTableView.
    _prepareTableUIForQuery: function() {
        // no need to prepare the table UI, if this is coming from the
        // paging contents. Otherwise, if this is a new query,
        // clear the display.
        if(this.queryToken == null && this.provider.preLoadPageContent)
            this.provider.preLoadPageContent();
        
    },

    
    // @override AbstractFilteredTableView to handle virtual select all case.
    hasSelectedRows: function()
    {
        var selectedItems = this.tableViewer.getCheckedRows();
        return (selectedItems == TableConstants.VIRTUAL_CONTENT_SELECT_ALL || selectedItems.length > 0);
    },

    _removeIdFromList: function(idType, list, id, compareFunc){
        var len = list.length;
        
        for (var i = 0; i < len; i++) {
            if(compareFunc(idType, list[i], id)) {
                list.splice(i, 1);
                return;
            }
        }
    },
    
    // Removes deselected rows from the 'all' item list. Caller must pass in
    // compare function to match the removed item. The returned list can be
    // the array of actual content objects, or just an array of ids.
    //
    _removeDeselectedItems: function(idType, allItems, compareFunc)
    {
        var deselectedItems = this.tableViewer.getVirtualDeselectedRows();
        var dlen = deselectedItems.length;
        if(dlen > 0) {
            for(var i = 0; i < dlen; i++) {
                var removeId = deselectedItems[i][idType];
                if(removeId) {
                    this._removeIdFromList(idType, allItems, removeId, compareFunc);
                }
            }
        }
        return allItems;
    },
    
    // Method to return selected all virtual contents' records. Upon returned
    // filter out any deselected items from the list. The user might have done a select
    // all and then deselect items before invoking actions.
    //
    getSelectedAllVirtualResultContents: function(idType, callback)
    {
        var fetchAllResultsFunc = dojo.hitch(this, function(idType, callback){
            if (this.queryToken) {
                var args = this._prepareQueryArgs(null, true);
                
                // reset the page arguments to fetch from top and
                // to fetch all.
                args.page = 0;
                args.pageSize = -1;
                
                var handler = {
                    self: this,
                    'success': function(resultsDTO){
                        // HACK: to workaround a irregular return result from TER search...
                        if (dojo.isArray(resultsDTO)) {
                            resultsDTO = resultsDTO[0];
                        }
                        // remove any delected items during a select all.
                        var contents = this.self._removeDeselectedItems(idType, resultsDTO.results, function(idType, row, id){
                            return (row[idType] == id);
                        });
                        callback(contents);
                    },
                    'error': function(){
                        this.self._showAlertDialog(Constants.getMessage("msgErrorFetchAll"));
                        callback([]);
                    }
                }
                var responseHandler = new this._searchResponseHandlerType(handler, "success", "error");
                this._searchFunction(responseHandler, args);
            }
        }, idType, callback);
        
        // check the current result set limit before invoking the operation
        // The server may not have all of the results for the query. This will
        // get us a new query token with the real full results.
        this._checkResultSetLimit(fetchAllResultsFunc);
    },
    
    // Method to return selected all virtual contents' item ids. Upon returned
    // filter out any deselected items from the list. The user might have done a select
    // all and then deselect items before invoking actions.
    //
    getSelectedAllVirtualContentItemIds: function(idType, context, funcName, param1, param2)
    {
        var fetchItemIdsFunc = dojo.hitch(this, function(idType, context, funcName, param1, param2){
            var handler = {
                context: context,
                self: this,
                idFieldName: (idType == "id") ? "ids" : "uuids",
                success: function(results){
                    // remove any delected items during a select all.
                    var allIds = this.self._removeDeselectedItems(idType, results[this.idFieldName], function(idType, idRec, id){
                        return idRec == id;
                    });
                    var actionFunc = dojo.hitch(this.context, funcName);
                    actionFunc(allIds, param1, param2);
                },
                failure: function(){
                    this.self._showAlertDialog(Constants.getMessage("msgErrorFetchAll"));
                }
            }
            var responseHandler = new ServiceResponseHandler(handler, "success", "failure");
            this._getAllResultsItemIds(responseHandler, {
                'queryToken': this.queryToken,
                'kindOfHandles': idType
            });
        }, idType, context, funcName, param1, param2);
        
        // check the current result set limit before invoking the operation
        // The server may not have all of the results for the query. This will
        // get us a new query token with the real full results.
        this._checkResultSetLimit(fetchItemIdsFunc);
    },
    
    // @override AbstractFilteredTableView to handle paged content select all token
    invokeAction: function(idType, context, funcName, param1, param2)
    {
        var selectedItems = this.tableViewer.getCheckedRows();
        
        // This is a select all case, get all content's ids from the server.
        if (selectedItems == TableConstants.VIRTUAL_CONTENT_SELECT_ALL) {
            this.getSelectedAllVirtualContentItemIds(idType, context, funcName, param1, param2);
        }
        else {
            var itemIds = [];
            var length = selectedItems.length;
            
            for (var i = 0; i < length; i++) {
                itemIds.push(selectedItems[i][idType]);
            }
            var actionFunc = dojo.hitch(context, funcName);
            actionFunc(itemIds, param1, param2);
        }
    },

    // abstract method to be used to get the all results' item ids. Subclasses must
    // override. E.g., this._getAllResultsItemIds = dojo.hitch(TestCaseClient, "getAllSearchResultItemIds");
    //
    _getAllResultsItemIds: function(responseHandler, params) {
        console.error("No client method provided for: _getAllResultsItemIds");
    },
    
    // @override - to handle virtual select all.
    // This path is used by the new print engine.  Not all artifact tables support this path yet so we
    // need to maintain both this method and _onPrintPdfActionClick below for the time being.
    _onPrintActionClick: function(printType) {
        // summary print
        if( !this.hasSelectedRows() ) {
            var content = this.tableViewer.getContent();
            var len = content ? content.length : 0;
            
            // the content is virtual and we don't have all the content
            // get the itemIds to invoke pdf print.
            if (this.contentIsVirtual && this.totalSize > len)
                this.getSelectedAllVirtualContentItemIds('id', this, "_doPrintAction");
            else if(len > 0) {
                // just print the content that we're showing.
                var ids = [];
                for(var i = 0; i < len; i++) {
                    ids.push(content[i].id);
                }
                this._doPrintAction(ids, printType, null);
            }
            
        }
        else {
            // printing detail contents. Also need to handle select all case.
            this.invokeAction('id', this, "_doPrintAction", printType, null);
        }
    },
    
    // @Override - to handle virtual select all.
    _onPrintPdfActionClick: function(/*optional*/ isHistory) {
        var isSummary = false;
        
        // no rows selected. It's a summary of all contents. Need to get all of
        // ids to print the summary of each row.
        if (!this.hasSelectedRows()) {
            isSummary = true;
            var content = this.tableViewer.getContent();
            var len = content ? content.length : 0;
            
            // the content is virtual and we don't have all the content
            // get the itemIds to invoke pdf print.
            if(this.contentIsVirtual && this.totalSize > len)
                this.getSelectedAllVirtualContentItemIds('id', this, "_doPrintPdfAction", isSummary, isHistory);
            else if(len > 0) {
                // just print the content that we're showing.
                var ids = [];
                for(var i = 0; i < len; i++) {
                    ids.push(content[i].id);
                }
                this._doPrintPdfAction(ids, isSummary, isHistory);
            }
            
        }
        else {
            // printing detail contents. Also need to handle select all case.
            this.invokeAction('id', this, "_doPrintPdfAction", isSummary, isHistory);
        }
    },
    
    addCSVExportAction: function(){    	
    	var isCsVEnabled = com.ibm.asq.common.web.ui.internal.util.Utility.isCSVEnabled();    	
    	if(isCsVEnabled && this.isQueryPage){
    		this.csvExportAction = this.tableViewer.addAction("csvExport", // action id
    				Constants.getMessage("labelCSVExport"),
    				null, // callback data
    				"csvexport-icon-image", // icon class 
    				dojo.hitch(this, "_getCSVExport"), // callback
    				null, null, /*readonly */true
    		);
    		return this.csvExportAction;
    	}
    	return null;
    },
    
    _getCSVExport:function(){    	
        var exportCSVFunc = dojo.hitch(this, function(){
            var queryToken = this.queryToken;
            var processArea = this.projectAreaItemId || getCurrentPA().itemId;
            var columnsProfile = dojo.clone(this.tableViewer.getColumnsProfile());
            var len = columnsProfile.length;
            var provider = this.tableViewer.getContentProvider();
            var content = this.tableViewer.getContent();
            
            for (var i = 0; i < len; i++) {
                var col = columnsProfile[i];
                var title = provider.getColumnHeading(content, col.index);
                
                //Add the tooltip for the (left-aligned) column image as a prefix for the CSV column name:
                var columnHeadingImage = provider.getColumnHeadingImage(content, col.index);
                
                if((columnHeadingImage != null) && (columnHeadingImage.leftAligned == true) && (columnHeadingImage.shownWithName == true)){
                	title = ("[" + columnHeadingImage.tooltip + "] " + title);
                }
                
                col.name = encodeURIComponent(col.name);
                col.title = encodeURIComponent(title);
            }
            
            var artifactList = null;
            if (this.totalPages <= 1) {
                artifactList = this._buildArtifactList(this.tableViewer.content);
                queryToken = null;
            }
            
            PrintHelper.submitPrintJob("csv", this.pdfPrintType, artifactList, queryToken, processArea, null, null, null, dojo.toJson(columnsProfile), null);
        });
        // check the current result set limit before invoking the operation
        // The server may not have all of the results for the query. This will
        // get us a new query token with the real full results.
        this._checkResultSetLimit(exportCSVFunc);
    },
    
    buildPrintMenu: function()
    {
    	var printOptions = PrintHelper.buildPrintMenuComplexResult(
		        this, "_submitPrintJob", 
		        this._supportsArtifactSummary, this._supportsComprehensive, this._supportsHistory, 
		        this._supportsTableSummary, false, (this.pdfPrintType == "testplan" || this.pdfPrintType == "testcase"), (this.pdfPrintType == "testcase"));

    	var Menu = printOptions.Menu;
    	this.printMenuActions = printOptions.MenuOptions;
    	
    	this._actionButtons.push(Menu);
		this._pdfButton = this.tableViewer.addAction(
		        "print-pdf",                           // id
		        Constants.getMessage("labelPDFView"),  // label 
		        null,                                  // callback data
		        "pdf-icon-image",                      // icon class
		        null,                                  // callback (not needed for menu button)
		        Menu,	                               // menu
		        null, true);
        return this._pdfButton;	        
    },
    
    // Summary:
    // create the table print action menu to be added to the table header.
    buildPrintTableMenu: function()
    {
        var printOptions = PrintHelper.buildTablePrintAction(this, "_submitPrintJob");

        var Menu = printOptions.Menu;
        this.printMenuActions = printOptions.MenuOptions;
        
        this._actionButtons.push(Menu);
        this._pdfButton = this.tableViewer.addAction("print-pdf",Constants.getMessage("labelPDFView"), null,  "pdf-icon-image", null, Menu, null, true); 
        return this._pdfButton;         
    },
    
    // Summary:
    // create the artifact action menu to be added to the row action provider.
    buildPrintArtifactActionMenu: function()
    {
        return PrintHelper.buildArtifactPrintAction(
                this, "_submitPrintJob",   // from AbstractFilteredTableView
                this._supportsArtifactSummary, 
                this._supportsComprehensive, 
                this._supportsHistory, 
                false, 
                (this.pdfPrintType == "testplan" || this.pdfPrintType == "testcase"), 
                (this.pdfPrintType == "testcase"));
    },

    addQuickCreateAction: function(actionArgs) {
    	// don't create the quick create action in the table, if 
    	// the configuraiton is read only.
    	if(this._readOnlyConfig) {
    		return;
    	}
        var tableViewer = this.tableViewer;
        this.quickCreateActionId = "quickCreate";
        tableViewer.addAction(this.quickCreateActionId,
            actionArgs.label,
            null, // callback data
            actionArgs.icon,
            dojo.hitch(this, function() { // callback
                this.newArtifactPopup = new quickCreateArtifactPopup({
                    modelType: actionArgs.modelType,
                    onSaveFinished: dojo.hitch(this, function(newArtifact) {
                        if (actionArgs.callback && dojo.isFunction(actionArgs.callback)) {
                            actionArgs.callback();
                        }
                        if (this.viewHeaderNode) {
                            this.viewHeaderNode.setStatus(
                                this._composeNewArtifactLink(newArtifact),
                                ViewHeaderLayout.SUCCESS,
                                null,  // details
                                null,  // errorObj
                                true); // notrim
                        }
                    })
                });
            })
        );
    },
    
    _composeNewArtifactLink: function(newArtifact) {
        if (!this.explorableArtifactType) {
            // non-nls development error message
            throw new Error("explorableArtifactType must be defined for quick create.");
        }
        var uri = "";
        var msgKey = null;
        switch (this.explorableArtifactType) {
            case Constants.MODEL_TYPE_PLAN:
                uri = Utility.getTestPlanURI({ id: newArtifact.id});
                msgKey = "labelCreatedTestPlan";
                break;
            case Constants.MODEL_TYPE_CASE:
                uri = Utility.getTestCaseURI(newArtifact.id);
                msgKey = "labelCreatedTestCase";
                break;
            case Constants.MODEL_TYPE_SCRIPT:
                uri = Utility.getTestScriptURI(newArtifact.id);
                msgKey = "labelCreatedTestScript";
                break;
            case Constants.MODEL_TYPE_SUITE:
                uri = Utility.getTestSuiteURI(newArtifact.id);
                msgKey = "labelCreatedTestSuite";
                break;
        }
        if (!msgKey) {
            // non-nls development error message
            throw new Error("Artifact type " + this.explorableArtifactType + " is not supported for quick create.");
        }
        var linkMsg = "";
        if (uri) {
            var title = newArtifact.name ? ("title='" + newArtifact.name + "' ") : "";
            linkMsg = Constants.getMessage("labelClickToOpenArtifact");
            // add the uri info to the link message
            linkMsg = linkMsg.replace("<a>", "<a " + title + "href='" + uri + "'>");
        }
        return Constants.getMessage(msgKey, linkMsg);
    },
    
    addBatchApprovalSupport: function(){
    	// don't provide batch approval actions, if 
    	// the configuraiton is read only.
    	if(this._readOnlyConfig) {
    		return;
    	}
    	if(this.actionProvider){    		
    		var approvalMenuEntries = [];

    		approvalMenuEntries.push({
    			label: Constants.getMessage("labelMarkApprovedReviewed"), 
    			callback: dojo.hitch(this, function(){    				       
    				this._executeApproveArtifacts(true);
    			}),
    			iconClass:"approve-button"
    		});

    		approvalMenuEntries.push({
    			label: Constants.getMessage("labelMarkRejected"), 
    			callback:dojo.hitch(this, function(){
    				this._executeApproveArtifacts(false);      				    				
    			}),
    			iconClass:"reject-button"
    		});
    		
    		var labelSingle = null;
    		var labelMultiple = null;
            var artifactType = this.explorableArtifactType;
            if (artifactType) {
                if (artifactType == Constants.MODEL_TYPE_PLAN) {
                    labelSingle = Constants.getMessage("labelReviewTestPlan");
                    labelMultiple = Constants.getMessage("labelReviewTestPlans");
                } else if (artifactType == Constants.MODEL_TYPE_CASE) {
                    labelSingle = Constants.getMessage("labelReviewTestCase");
                    labelMultiple = Constants.getMessage("labelReviewTestCases");
                } else if (artifactType == Constants.MODEL_TYPE_SCRIPT) { 
                    labelSingle = Constants.getMessage("labelReviewTestScript");
                    labelMultiple = Constants.getMessage("labelReviewTestScripts");
                } else if (artifactType == Constants.MODEL_TYPE_SUITE) {
                    labelSingle = Constants.getMessage("labelReviewTestSuite");
                    labelMultiple = Constants.getMessage("labelReviewTestSuites");
                }
            }
    		this.actionProvider.addApproveArtifactAction(approvalMenuEntries, labelSingle, labelMultiple);   
    	}
    },
    
    //Summary:
    //Search the missing back links for the specific artifact type, Constants.MODEL_TYPE_PLAN or Constants.MODEL_TYPE_CASE
    searchMissingBackLinks: function(artifactType, monitor){
        if (ConfigurationUtil.isPleEnabled()) {
            // backlink is not applicable if opted in to PLE
            return [];
        }
        
    	var clz = "com.ibm.rqm.defects.web.ui.internal.ClmLinksHelper";
    	if(dojo.getObject(clz)){
    		return this._searchMissingBackLinks(artifactType, monitor);
    	} else {
    		jazz.core.loader.load_async(clz, dojo.hitch(this, function(){
    			return this._searchMissingBackLinks(artifactType, monitor);
    		}))
    	}
    },
    
    _searchMissingBackLinks: function(artifactType, monitor){
    	//the items in the current page
		var items = this.tableViewer.content;
		
		var cmLinksHelper = null;
		var rmLinksHelper = null;
		
		if(artifactType == Constants.MODEL_TYPE_PLAN){
				cmLinksHelper = new com.ibm.rqm.defects.web.ui.internal.DevPlanClmLinksHelper();
				rmLinksHelper = new com.ibm.rqm.defects.web.ui.internal.RmCollectionClmLinksHelper();
		} else if(artifactType == Constants.MODEL_TYPE_CASE){
				cmLinksHelper = new com.ibm.rqm.defects.web.ui.internal.DevItemClmLinksHelper();
				rmLinksHelper = new com.ibm.rqm.defects.web.ui.internal.RmClmLinksHelper();
		}
		
		var rmToFix = null;
		var cmToFix = null;
		var callback = dojo.hitch(this, function(){
			if(!rmToFix || !cmToFix){
				return;
			} else {
				this._renderBadBackLinks(rmToFix.concat(cmToFix));
			}
		});
		
		var defferedList1 = cmLinksHelper.discoveryMissedBackLink(items, dojo.hitch(this, function(result){
			cmToFix = result;
			callback();
		}), monitor);
		var defferedList2 = rmLinksHelper.discoveryMissedBackLink(items, dojo.hitch(this, function(result){
			rmToFix = result;
			callback();
		}), monitor);
		
		return (defferedList1.concat(defferedList2));
	},
	
	afterRepairedBackLink: function(rowData, remoteItem) {
		var items = this.tableViewer.content;
		
		dojo.forEach(items, function(item){
			if(item.itemId == rowData.itemId){
				var linkTypeDTOs = item.linkTypeDTOs || [];
				dojo.forEach(linkTypeDTOs, function(linkTypeDTO){
						dojo.forEach(linkTypeDTO.linkDTOs, function(linkDTO){
							if(linkDTO.url == remoteItem.uri && linkDTO.missingBackLink){
								//after repair the back link, update the missingBackLink flag.
								delete linkDTO.missingBackLink;
							}
						});
				});
			}
		});
		
		this.tableViewer.refresh();
	},
	
	_renderBadBackLinks: function(remoteItems) {
		var items = this.tableViewer.content;
		
		dojo.forEach(items, function(item){
			var itemId = item.itemId;
			var linkTypeDTOs = item.linkTypeDTOs || [];
			dojo.forEach(linkTypeDTOs, function(linkTypeDTO){
					var linkTypId = linkTypeDTO.id;
					dojo.forEach(linkTypeDTO.linkDTOs, function(linkDTO){
						dojo.forEach(remoteItems, function(remoteItem){
							if(remoteItem.url == linkDTO.url){
								for(var i in remoteItem.artifacts){
									if(remoteItem.artifacts[i].itemId == itemId){
										//flag missingBackLink where the back link is missing.
										linkDTO.missingBackLink = true;
									}
								}
							}
						});
					});
			});
		});
		
		this.tableViewer.refresh();
	},

    _executeApproveArtifacts: function(isReview){
        var execApproveFunc = dojo.hitch(this, function(isReview){
            var artifactType = "";
            var artifactPackageUri = Constants.PACKAGE_URI;
            var itemIdName = "versionableItemId";
            var artifactLocalType = this.explorableArtifactType;
            
            if (artifactLocalType == Constants.MODEL_TYPE_PLAN) { 
                artifactType = Constants.PLAN_TYPE;
            } else if (artifactLocalType == Constants.MODEL_TYPE_CASE) { 
                artifactType = Constants.CASE_TYPE; 
            } else if (artifactLocalType == Constants.MODEL_TYPE_SCRIPT) { 
                artifactType = Constants.SCRIPT_TYPE; 
            } else if (artifactLocalType == Constants.MODEL_TYPE_SUITE) {
                artifactType = Constants.SUITE_TYPE;
            } else if (artifactLocalType == Constants.MODEL_TYPE_RESULT) {
                artifactType = Constants.EXECUTION_RESULT_TYPE;
                artifactPackageUri = Constants.EXECUTION_PACKAGE_URI;
                itemIdName = "itemId";
            } else if (artifactLocalType == Constants.MODEL_TYPE_SUITE_LOG) {
                artifactType = Constants.SUITE_RESULT_TYPE;
                artifactPackageUri = Constants.EXECUTION_PACKAGE_URI;
                itemIdName = "itemId";
            }
            
        	this.getVirtualSelectedRows('itemId', dojo.hitch(this, function(selectedItems) {
        		var itemIds = [];
        		var length = selectedItems.length;
        		var checkedTeamArea = {};
        		var processArea = jazz.app.context.get().itemId;
        		var teamAreas = [];
                for (var i = 0; i < length; i++) {
                    itemIds.push(selectedItems[i][itemIdName]);
                    var teamArea = selectedItems[i].teamArea || processArea;
                    if (!checkedTeamArea[teamArea]){
                       checkedTeamArea[teamArea] = true;
                       teamAreas.push(teamArea);
                    }
                }
                var approvalBulk = new com.ibm.rqm.planning.web.ui.internal.model.action.ApprovalBulkChangeAction({
                    artifactType: artifactType,
                    'artifactPackageUri': artifactPackageUri,
                    itemIds: itemIds,
                    teamAreas: teamAreas,
                    isReview: isReview,
                    completeCallback: dojo.hitch(this, "_invalidateQuery")
                });
                approvalBulk.execute();
        	}));
            
        }, isReview);
        
        // not select all for the operation, we can't just go ahead
        // with the operation.
        var selectedItems = this.getSelectedItems();
        if (selectedItems != TableConstants.VIRTUAL_CONTENT_SELECT_ALL) {
            execApproveFunc();
            return;
        }
        // check the current result set limit before invoking the operation
        // The server may not have all of the results for the query. This will
        // get us a new query token with the real full results.
        this._checkResultSetLimit(execApproveFunc);
    },
    
    _buildArtifactList: function(items) {
        var artifactList = [];
        
        for (var i=0; i < items.length; i++)         
    		artifactList.push(PrintHelper.createArtifactObject(this.getID(items[i]), null));
    	
    	return artifactList;
    },
    
    getID: function(item) {
        //Some tables have the id encapsulated (BuildRecord) so those will override this.
        return item.id;
    },
    
    _submitPrintJob: function(printType, mimeType) {
        var printFunc = dojo.hitch(this, function(printType, mimeType){
            var queryToken;
            var processArea;
            var artifactList;
            
            // batch print job
            // for table-summary job, will still show current page or all page even 
            // though rows selected
            if (this.hasSelectedRows() && printType!="table-summary" && printType!="table-summary-all") {
                var selectedItems = this.getSelectedItems();
                
                // certain items
                if (selectedItems != TableConstants.VIRTUAL_CONTENT_SELECT_ALL) {
                    artifactList = this._buildArtifactList(selectedItems);
                // all items
                }
                else {
                    queryToken = this.queryToken;
                    processArea = getCurrentPA().itemId;
                }
            // table summary print job
            }
            else {
                if (this.totalPages > 1 && (printType && dojo.isString(printType) && printType == "table-summary-all")) {
                    queryToken = this.queryToken;
                    processArea = getCurrentPA().itemId;
                }
                else 
                    if ((printType && dojo.isString(printType) && printType == "table-summary") || this.totalPages == 1) {
                        artifactList = this._buildArtifactList(this.tableViewer.content);
                    }
            }
            
            PrintHelper.submitPrintJob(printType, this.pdfPrintType, artifactList, queryToken, processArea, null, null, null, null, null);
        }, printType, mimeType);
        
        // check the current result set limit before invoking the operation
        // The server may not have all of the results for the query. This will
        // get us a new query token with the real full results.
        this._checkResultSetLimit(printFunc);
    },
    
    // Summary:
    //    Returns selected rows from the table. If the selection is a select all
    //    and we are showing virtual content, this method will fetch the entire content
    //    to return. 
    //      idType - the id attribute to use to filter out deselected items in a select all context (id, itemId, etc.)
    //      callback - method to receive the returned item. The callback is called with the returned items: callback(items)
    // 
    getVirtualSelectedRows: function(idType, callback) {
        var selectrows = this.tableViewer.getCheckedRows();
        
        // not a select all, just return the rows
        // right away.
        if(dojo.isArray(selectrows)) {
            callback(selectrows);
        }
        else {
            // It's a virtual select all. Get all results contents.
            // It will remove any rows that have been deselected from
            // the select all set.
            this.getSelectedAllVirtualResultContents(idType, callback);
        }            
    },
    
    // Summary:
    //   convenient method to rerun the current query to pickup any content
    //   changes.
    _invalidateQuery: function () {
        // the selection may not be the same, clear them before rerun the query
		// don't have to refresh the display, since the current result would be
		// clear by refresh query.
        this.tableViewer.clearSelection(true /* notify */, false /* refreshDisplay */);

        // clear the token to invalidate last ran query
        this.queryToken = null;
        this._keepCurrentPage = true;
        this.refreshQuery(null);
    },
    
    // Summary:
    //    Before we perform actions on the entire query result set (virtual select all),
    //    we have to check the current result set size on the server to see if it covers
    //    the current result set total size. If not, we have to make a call to remove the
    //    result set limit for the operation.
    //
    _checkResultSetLimit: function(onComplete) {
        // the server side result set size covers the current result's
        // total size. Don't have to invalidate the query on the server
        // to remove the result set limit. We can just go ahead
        // to continue with the operation.
        //
        if(this.resultSetSize >= this.totalSize) {
//console.debug("Passing thru... no need to remove result set limit...")            
            onComplete();
            return;
        }
        
//console.debug("start to remove result set limit...")            
        var args = this._prepareQueryArgs(null, true);
        var self = this;
        var callback = {
            success: function(resultsDTO){
                // update the query token & the resultSetSize
                var provider = self.provider;
                self.queryToken = resultsDTO.queryToken;
                self.resultSetSize = resultsDTO.resultSetSize;
                /*
                 * don't record these stat...
                provider.currentPageIndex = self.currentPage = resultsDTO.currentPage;
                provider.totalPageCount = self.totalPages = resultsDTO.totalPages;
                provider.totalContentCount = self.totalSize = resultsDTO.totalSize;
                */
                onComplete();
            },
            failure: function(error){
                onComplete();
            }
        }
        
        // specify the project area.
        if(this.projectAreaItemId) {
            args.processArea = this.projectAreaItemId;
        }
        // remove the result limit and clear the query token
        // make the page size 0 to not return any content for 
        // the query. This call is really to tickle the server
        // to remove the result limit for the up coming bulk update
        // call.
        args.resultLimit = 0;
        args.pageSize = 0;
        if(args.queryToken) {
            delete args.queryToken;
        }
        if (args.totalSize) {
            delete args.totalSize;
        }        
        var responseHandler = new this._searchResponseHandlerType(callback, "success", "failure");          
        this._searchFunction(responseHandler, args);
    }
});

})();
