<?xml version="1.0" encoding="utf-8"?>
<!-- 
    /****************************************************************************** 
    * Licensed Materials - Property of IBM
    * (c) Copyright IBM Corporation 2011, 2014. All Rights Reserved.
    *  
    * U.S. Government Users Restricted Rights:
    * Use, duplication or disclosure restricted by GSA ADP Schedule
    * Contract with IBM Corp.
    ******************************************************************************/
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format"
    xmlns:prep="http://com.ibm.rqm.print/prep"
    xmlns:rqm="http://jazz.net/xmlns/alm/qm/v0.1/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:alm="http://jazz.net/xmlns/alm/v0.1/"
    xmlns:time="xalan://com.ibm.rqm.print.render.fop.xml.xslt.extension.TimeUtilsExtension"
    xmlns:utils="xalan://com.ibm.rqm.print.render.fop.xml.xslt.extension.UtilsExtension"
    exclude-result-prefixes="xsl rqm time utils">
    
    <!-- for debugging only -->
    <xsl:include href="cache://stylesheets/render/_config/attribute-sets.xsl"/>
    
    <xsl:template name="buildExecutionSequenceTable">
        <xsl:param name="strings"/>
        <xsl:param name="sequences"/>
        
        <xsl:param name="render-id"/>
        <xsl:param name="render-name"/>
        <xsl:param name="render-owner"/>
        <xsl:param name="render-modified"/>
        <xsl:param name="render-history"/>
        
        <fo:table xsl:use-attribute-sets="artifact-table">
            <fo:table-header xsl:use-attribute-sets="artifact-table-header">
                <!-- ID -->
                <xsl:if test="$render-id">
                    <fo:table-cell xsl:use-attribute-sets="artifact-table-header-cell id-header">
                        <fo:block><xsl:value-of select="$strings/ID"/></fo:block>
                    </fo:table-cell>
                </xsl:if>
                <!-- Name -->
                <xsl:if test="$render-name">
                    <fo:table-cell xsl:use-attribute-sets="artifact-table-header-cell">
                        <fo:block><xsl:value-of select="$strings/Name"/></fo:block>
                    </fo:table-cell>    
                </xsl:if>
                <!-- Owner -->
                <xsl:if test="$render-owner">
                    <fo:table-cell xsl:use-attribute-sets="artifact-table-header-cell">
                        <fo:block><xsl:value-of select="$strings/Owner"/></fo:block>
                    </fo:table-cell>    
                </xsl:if>
                <!-- Modified -->
                <xsl:if test="$render-modified">
                    <fo:table-cell xsl:use-attribute-sets="artifact-table-header-cell timestamp-header">
                        <fo:block><xsl:value-of select="$strings/Modified"/></fo:block>
                    </fo:table-cell>    
                </xsl:if>
                <!-- History -->
                 <xsl:if test="$render-history">
                    <fo:table-cell xsl:use-attribute-sets="artifact-table-header-cell">
                        <fo:block><xsl:value-of select="$strings/History"/></fo:block>
                    </fo:table-cell>    
                </xsl:if>
            </fo:table-header>
            <fo:table-body>
                <xsl:for-each select="$sequences">
                    <fo:table-row>
                        <!-- ID -->
                        <xsl:if test="$render-id">
                            <fo:table-cell xsl:use-attribute-sets="artifact-table-body-cell id-cell">
                                <fo:block-container overflow="hidden">
                                	<fo:block><xsl:value-of select="rqm:webId"/></fo:block>
                                </fo:block-container>
                            </fo:table-cell>
                        </xsl:if>
                        <!-- Name -->
                        <xsl:if test="$render-name">
                            <fo:table-cell xsl:use-attribute-sets="artifact-table-body-cell">
                                <fo:block-container overflow="hidden">
                                	<fo:block><xsl:apply-templates select="dc:title"/></fo:block>
                            	</fo:block-container>
                            </fo:table-cell>
                        </xsl:if>
                        <!-- Owner -->
                        <xsl:if test="$render-owner">
                            <fo:table-cell xsl:use-attribute-sets="artifact-table-body-cell">
                                <fo:block-container overflow="hidden">
                                	<fo:block><xsl:apply-templates select="prep:owner"/></fo:block>
                            	</fo:block-container>
                            </fo:table-cell>
                        </xsl:if>
                        <!-- Modified -->
                        <xsl:if test="$render-modified">
                            <fo:table-cell xsl:use-attribute-sets="artifact-table-body-cell timestamp-cell">
                                <fo:block-container overflow="hidden">
                                	<fo:block><xsl:value-of select="time:formatMediumDate(alm:updated, $locale)"/></fo:block>
                            	</fo:block-container>
                            </fo:table-cell>
                        </xsl:if>
                        <!-- History -->
                        <xsl:if test="$render-history">
                            <fo:table-cell xsl:use-attribute-sets="artifact-table-body-cell">
                                <fo:block-container overflow="hidden">
                                	<fo:block>
                                		<fo:basic-link xsl:use-attribute-sets="simple-link" external-destination="{utils:getExecScheduleHistoryURL(dc:identifier, rqm:webId)}">
                        					<fo:external-graphic
                    							src="{'basecache://com.ibm.asq.common.web/resources/ui/internal/images/icons/obj16/qm_execseq16.gif'}"
                    							scaling="uniform" scaling-method="integer-pixels" content-width="50%"/>
                    					</fo:basic-link>
                                	</fo:block>
                            	</fo:block-container>
                            </fo:table-cell>
                        </xsl:if>
                    </fo:table-row>
                </xsl:for-each>
            </fo:table-body>
        </fo:table>
    </xsl:template>
    
</xsl:stylesheet>